package cn.iocoder.yudao.module.shipment.enums;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;

public interface ErrorCodeConstants {
    ErrorCode BOX_NOT_EXISTS = new ErrorCode(1109010001, "shipment.not.exists");
    ErrorCode BOX_ORDER_EXIT_NOT_EXISTS = new ErrorCode(1109010002, "shipment.order.exit.not.exists");

    ErrorCode LINE_NOT_OPEN = new ErrorCode(1109010003, "line.not.open");

    ErrorCode LADING_TEMPLATE_NOT_SET = new ErrorCode(1109010004, "lading.template.not.set");

    ErrorCode BOX_BOOK_SEA_NOT_EXISTS = new ErrorCode(1109010005, "booking.not.exist");

    ErrorCode BOX_WAREHOUSE_START_NOT_MATCH = new ErrorCode(1109010006, "box.warehouse.start.not.match");

    ErrorCode BOX_WAREHOUSE_DEST_NOT_MATCH = new ErrorCode(1109010007, "box.warehouse.dest.not.match");

    ErrorCode BOX_VOLUME_EXCEED = new ErrorCode(1109010008, "box.volume.exceed");

    ErrorCode BOX_WEIGHT_EXCEED = new ErrorCode(1109010009, "box.weight.exceed");

    ErrorCode BOX_ABNORMAL_NOT_EXISTS = new ErrorCode(1109010010, "box.abnormal.not.exist");

    ErrorCode BOX_LOAD_EXISTS = new ErrorCode(1109010011, "box.load.exist");

    ErrorCode BOX_LOAD_NOT_EXISTS = new ErrorCode(1109010012, "box.load.not.exist");

    ErrorCode BOX_BOOK_AIR_NOT_EXISTS = new ErrorCode(1109010013, "box.book.air.not.exist");

    ErrorCode BOX_CHECKOUT_AIR_NOT_EXISTS = new ErrorCode(1109010014, "box.checkout.air.not.exist");

    ErrorCode BOX_INSTALL_NOT_MATCH = new ErrorCode(1109010015, "box.install.not.match");

    ErrorCode BOX_UNLOAD_NOT_MATCH = new ErrorCode(1109010016, "box.unload.not.match");

    ErrorCode BOX_CABINET_TIP = new ErrorCode(1109010017, "please.install.and.pass.audit");

    ErrorCode MAKE_BILL_OF_LADING_NOT_EXISTS = new ErrorCode(1109010018, "bill.of.lading.not.exist");
    ErrorCode MAKE_BILL_OF_LADING_EXISTS = new ErrorCode(1109010019, "bill.of.lading.exist");

    ErrorCode FUTURE_BOX_NOT_EXISTS = new ErrorCode(1109010020, "cabin.plan.not.exist");

    ErrorCode FILE_NOT_EXISTS = new ErrorCode(1109010021, "file.not.upload");

    ErrorCode HAVE_NOT_LADING = new ErrorCode(1109010022, "lading.not.make");

    ErrorCode HAVE_NOT_PRELOAD_GOODS = new ErrorCode(1109010023, "preload.not.exist");

    ErrorCode LADING_BILL_NOT_EXIST = new ErrorCode(1109010024, "lading.bill.not.exist");
    ErrorCode REFUND_NUM_NOT_BE_GT_NUM = new ErrorCode(1109010025, "refund.num.not.be.gt.num");
    ErrorCode WORK_FLOW_NOT_EXITS = new ErrorCode(1109010026, "work.flow.not.exits");
    ErrorCode THIS_ORDER_NOT_PART_REFUND_ORDER = new ErrorCode(1109010027, "this.order.not.part.refund.order");
    ErrorCode THIS_ORDER_NOT_BE_PART_REFUND = new ErrorCode(1109010028, "this.order.not.be.part.refund");
    ErrorCode THIS_ORDER_PART_REFUND_PENDING = new ErrorCode(1109010029, "this.order.part.refund.pending");
    ErrorCode THIS_ORDER_PART_REFUND_FINISH = new ErrorCode(1109010030, "this.order.part.refund.finish");
    ErrorCode ORDER_SPLIT_DATA_NOT_EXITS = new ErrorCode(1109010031, "order.split.data.not.exits");
    ErrorCode PART_REFUND_ORDER_NUM_NOT_CORRECT = new ErrorCode(1109010032, "part.refund.order.num.not.correct");
    ErrorCode BOX_ORDER_EXIT_REFUND_NUM_NOT_NULL = new ErrorCode(1109010033, "order.exit.refund.num.not.null");
    ErrorCode BOX_ORDER_EXIT_REFUND_NUM_MUST_LE_NUM = new ErrorCode(1109010034, "order.exit.refund.num.must.le.num");
    ErrorCode BOX_ORDER_EXIT_WAREHOUSE_IN_FINISH = new ErrorCode(1109010035, "order.exit.warehouse.in.finish");
    ErrorCode EXIT_ORDER_IS_EXITS = new ErrorCode(1109010036, "exit.order.is.exits");
    ErrorCode SHIPMENT_ORDER_IS_NOT_EXITS = new ErrorCode(1109010037, "shipment.order.is.not.exits");
    ErrorCode DEST_COUNTRY_NOT_EXITS = new ErrorCode(1109010038, "dest.country.not.exits");

    ErrorCode BOX_REPORT_NOT_EXIST = new ErrorCode(1109010039, "box.report.not.exist");
    ErrorCode BOX_APPROVAL_EXIST = new ErrorCode(1109010040, "box.approval.exist");

    ErrorCode BOX_MERGE_PKG_NOT_EXISTS = new ErrorCode(1109010025, "合包箱不存在");

    ErrorCode COUNTRY_LABEL_CODE_NOT_EXISTS = new ErrorCode(1109010026, "国家代号未配置，请先配置国家代号");

    ErrorCode BOX_PKG_ORDER_NOT_EXISTS = new ErrorCode(1109010027, "合包订单不存在");

    ErrorCode BOX_AIR_SHIPMENT_NOT_EXISTS = new ErrorCode(1109010028, "空运出货不存在");

    ErrorCode BOX_AIR_CHECKOUT_NOT_EXISTS = new ErrorCode(1109010029, "空运出仓不存在");

    ErrorCode BOX_AIR_FLY_NOT_EXISTS = new ErrorCode(1109010030, "起飞不存在");

    ErrorCode BOX_WAREHOUSED_NOT_MATCH = new ErrorCode(1109010031, "box.warehoused.not.match");

    ErrorCode MERGE_PKG_STATUS_CAN_NOT_FINISH = new ErrorCode(1109010041, "box.merge.pkg.status.can.not.finish");

    ErrorCode MERGE_PKG_IS_FINISH = new ErrorCode(1109010042, "box.merge.pkg.is.finish");

    ErrorCode BOX_AIR_CHECKOUT_REPEAT_COMMIT = new ErrorCode(1109010043, "box.air.checkout.repeat.commit");

    ErrorCode MAKE_BILL_OF_SELF_NULL = new ErrorCode(1109010044, "制作提单时自编号不能为空");

    ErrorCode MAKE_BILL_OF_ORDER_NULL = new ErrorCode(1109010045, "制作提单时提单号不能为空");

    ErrorCode BOX_AIR_CHECKOUT_NUM_ERROR = new ErrorCode(1109010046,"box.air.checkout.num.error");

    ErrorCode BOX_ORDER_CHECK_INFO_NOT_EXISTS = new ErrorCode(1109010047, "理货和合包标签不存在");

    ErrorCode BOX_ORDER_CHECK_ALREADY_EXISTS = new ErrorCode(1109010048, "{}已关联其他箱号{}");

    ErrorCode BOX_TALLY_FINISHED = new ErrorCode(1109010049, "理货已完成，反审后才能操作");

    ErrorCode BOX_MERGE_PKG_FINISHED = new ErrorCode(1109010050, "合包已完成，反审后才能操作");

    ErrorCode ORDER_INSTALL_NOT_MATCH = new ErrorCode(1109010051, "{}已装箱数量与计划数量不一致");

    ErrorCode AIR_CHECKOUT_NOT_MATCH = new ErrorCode(1109010052, "出仓箱数与计划数量不一致");

    ErrorCode BOX_MAKE_LADING_REPEAT_COMMIT = new ErrorCode(1109010053,"box.make.lading.repeat.commit");

    ErrorCode BOX_AIR_LOAD_EXIST = new ErrorCode(1109010053,"box.air.load.exist");

    ErrorCode MERGE_PKG_NOT_IN_BOX = new ErrorCode(1109010053,"merge.pkg.not.in.box");

    ErrorCode ORDER_CASE_NUM_NOT_IN_BOX = new ErrorCode(1109010054,"order.case.num.not.in.box");

    ErrorCode ORDER_CASE_NUM_ALREADY_TALLY = new ErrorCode(1109010055,"order.case.num.already.tally");

    ErrorCode ORDER_NOT_IN_BOX = new ErrorCode(1109010056,"order.not.in.box");

    ErrorCode ORDER_CASE_NUM_NOT_EXIST = new ErrorCode(1109010057,"order.case.num.not.exist");

    ErrorCode CASE_NUM_IN_MERGE_PKG = new ErrorCode(1109010058,"case.num.in.merge.pkg");

    ErrorCode ORDER_IN_MERGE_PKG = new ErrorCode(1109010059,"order.already.in.merge.pkg");
    ErrorCode BOX_UPDATE_REPEAT_COMMIT = new ErrorCode(1109010060, "box.update.repeat.commit");

}