package cn.iocoder.yudao.module.shipment.service.boxPreloadGoods;

import cn.hutool.core.collection.CollectionUtil;
import cn.iocoder.yudao.framework.common.exception.ServiceException;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.collectors.CollectorsUtil;
import cn.iocoder.yudao.framework.i18n.core.I18nMessage;
import cn.iocoder.yudao.framework.i18n.core.LangEnum;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.depository.dal.dataobject.warehouse.WarehouseDO;
import cn.iocoder.yudao.module.depository.dal.dataobject.warehouse.WarehouseLineDO;
import cn.iocoder.yudao.module.depository.dal.mysql.warehouse.WarehouseLineMapper;
import cn.iocoder.yudao.module.depository.service.warehouse.WarehouseService;
import cn.iocoder.yudao.module.ecw.dal.dataobject.cabinet.CabinetDO;
import cn.iocoder.yudao.module.ecw.service.cabinet.CabinetService;
import cn.iocoder.yudao.module.order.convert.order.OrderConvert;
import cn.iocoder.yudao.module.order.convert.orderException.OrderExceptionConvert;
import cn.iocoder.yudao.module.order.convert.orderItem.OrderItemConvert;
import cn.iocoder.yudao.module.order.dal.dataobject.approval.OrderApprovalDO;
import cn.iocoder.yudao.module.order.dal.dataobject.order.OrderDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderConsignee.OrderConsigneeDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderException.OrderExceptionDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderGuanlian.OrderGuanlianDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderItem.OrderItemDO;
import cn.iocoder.yudao.module.order.enums.OrderStatusEnum;
import cn.iocoder.yudao.module.order.service.order.*;
import cn.iocoder.yudao.module.order.service.orderException.OrderExceptionService;
import cn.iocoder.yudao.module.order.vo.order.OrderPreloadReq;
import cn.iocoder.yudao.module.order.vo.order.OrderPreloadVO;
import cn.iocoder.yudao.module.order.vo.orderGuanlian.OrderTree;
import cn.iocoder.yudao.module.order.vo.orderItem.OrderItemBackVO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductAttrDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceDO;
import cn.iocoder.yudao.module.product.service.product.ProductAttrService;
import cn.iocoder.yudao.module.sale.dal.dataobject.channel.ChannelDO;
import cn.iocoder.yudao.module.sale.service.channel.ChannelService;
import cn.iocoder.yudao.module.shipment.convert.BoxAbnormalConvert;
import cn.iocoder.yudao.module.shipment.convert.BoxCustomsConvert;
import cn.iocoder.yudao.module.shipment.convert.BoxPreloadGoodsConvert;
import cn.iocoder.yudao.module.shipment.convert.BoxPreloadSectionConvert;
import cn.iocoder.yudao.module.shipment.dal.dataobject.*;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxOrderCheckInfo.BoxOrderCheckInfoDO;
import cn.iocoder.yudao.module.shipment.dal.mysql.BoxPreloadGoodsMapper;
import cn.iocoder.yudao.module.shipment.enums.*;
import cn.iocoder.yudao.module.shipment.service.box.BoxService;
import cn.iocoder.yudao.module.shipment.service.boxCustoms.BoxCustomsService;
import cn.iocoder.yudao.module.shipment.service.boxCustomsExtraCost.BoxCustomsExtraCostService;
import cn.iocoder.yudao.module.shipment.service.boxLoadInfo.BoxLoadInfoService;
import cn.iocoder.yudao.module.shipment.service.boxMergePkg.BoxMergePkgService;
import cn.iocoder.yudao.module.shipment.service.boxOrderCheckInfo.BoxOrderCheckInfoService;
import cn.iocoder.yudao.module.shipment.service.boxPkgOrder.BoxPkgOrderService;
import cn.iocoder.yudao.module.shipment.service.boxPreloadSection.BoxPreloadSectionService;
import cn.iocoder.yudao.module.shipment.service.boxTally.BoxTallyService;
import cn.iocoder.yudao.module.shipment.vo.box.BoxGoodsStatistics;
import cn.iocoder.yudao.module.shipment.vo.box.PreloadResultVO;
import cn.iocoder.yudao.module.shipment.vo.boxLoadInfo.BoxLoadInfoQueryVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadGoods.*;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadSection.BoxLoadDetailBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadSection.BoxLoadSectionBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadSection.BoxPreloadSectionBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadSection.BoxPreloadSectionDetailVO;
import cn.iocoder.yudao.module.system.controller.admin.dict.vo.data.DictDataExportReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.dict.DictDataDO;
import cn.iocoder.yudao.module.system.service.dict.DictDataService;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.google.common.base.Joiner;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.order.enums.ErrorCodeConstants.ORDER_HAS_PROCESSING_APPROVAL;
import static cn.iocoder.yudao.module.shipment.enums.ErrorCodeConstants.*;

/**
 * 预装货物 Service 实现类
 *
 * @author wlh
 */
@Service
@Validated
public class BoxPreloadGoodsServiceImpl extends AbstractService<BoxPreloadGoodsMapper, BoxPreloadGoodsDO> implements BoxPreloadGoodsService {

    @Resource
    private BoxPreloadGoodsMapper boxPreloadGoodsMapper;

    @Resource
    BoxService boxService;
    @Resource
    BoxPreloadSectionService boxPreloadSectionService;

    @Resource
    WarehouseService warehouseService;
    @Resource
    OrderItemService orderItemService;
    @Resource
    OrderDepartureService departureService;
    @Resource
    OrderObjectiveService objectiveService;
    @Resource
    CabinetService cabinetService;
    @Resource
    WarehouseLineMapper warehouseLineMapper;
    @Resource
    BoxLoadInfoService boxLoadInfoService;
    @Resource
    OrderService orderService;

    @Resource
    OrderQueryService orderQueryService;
    @Resource
    @Lazy
    BoxCustomsExtraCostService boxCustomsExtraCostService;
    @Resource
    private OrderExceptionService orderExceptionService;
    @Resource
    OrderMutualService orderMutualService;
    @Resource
    OrderGuanlianService orderGuanlianService;
    @Resource
    private DictDataService dictDataService;
    @Resource
    private ProductAttrService productAttrService;
    @Resource
    private ChannelService channelService;

    @Resource
    private BoxCustomsService boxCustomsService;

    @Resource
    private BoxPkgOrderService pkgOrderService;

    @Resource
    private BoxMergePkgService boxMergePkgService;

    @Resource
    private BoxTallyService boxTallyService;

    @Resource
    @Lazy
    private BoxOrderCheckInfoService boxOrderCheckInfoService;

    @Resource
    @Lazy
    private BoxPkgOrderService boxPkgOrderService;

    @Override
    public PreloadResultVO createBoxPreloadGoodsV2(BoxPreloadGoodsCreateReqVO createReqVO) {
        Long shipmentId = createReqVO.getShipmentId();

        //找到出货单
        BoxDO boxDO = boxService.getBox(shipmentId);
        if (boxDO == null) {
            throw exception(BOX_NOT_EXISTS);
        }

        boxService.checkApproval(shipmentId, null);

        if (createReqVO.getIsCover() == 0) {
            //排单，先校验出货是否已经预装审核通过了
            Integer prStatus = boxDO.getPrStatus();
            if (prStatus == PrStatusEnum.PRELOAD_APPROVAL_SUCCESS.getPrStatus()) {
                throw new ServiceException(500, "出货已排单审核通过。");
            }
        }

        Long orderId = createReqVO.getOrderId();
        Long secId = createReqVO.getSecId();

        //找到这个出货单已预装的商品
        List<BoxPreloadGoodsDO> loadList = baseMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        OrderDO orderDO = orderService.getById(orderId);

        //如果都符合，下面展示互斥和关联订单的弹窗
        Integer relationStatus = createReqVO.getRelationStatus();
        //校验是否是互斥订单
        if (relationStatus == null || relationStatus == 2) {
            //校验互斥订单
            checkMutualOrder(loadList, orderDO);
        }

        List<OrderGuanlianDO> orderRelationList = null;
        boolean hasRelationOrder = false;
        if (!createReqVO.isSingleLoad()) {
            //所有关联订单
            orderRelationList = orderGuanlianService.getRelationList(orderId);
            hasRelationOrder = CollectionUtil.isNotEmpty(orderRelationList);
        }

        List<OrderDO> orderList;
        StringBuilder sb = new StringBuilder();

        if (hasRelationOrder) {
            Set<Long> orderIdSet = orderRelationList.stream()
                    .flatMap(o -> Stream.of(o.getOrderId(), o.getRelateOrderId()))
                    .collect(Collectors.toSet());

            //找出这些订单是否已经预装
            List<BoxPreloadGoodsDO> orderLoadList = baseMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                    .in(BoxPreloadGoodsDO::getOrderId, orderIdSet)
                    .eq(BoxPreloadGoodsDO::getIsRemove, 0)
            );
            if (CollectionUtil.isNotEmpty(orderLoadList)) {
                Set<Long> loadOrderIdList = orderLoadList.stream()
                        .map(BoxPreloadGoodsDO::getOrderId)
                        .collect(Collectors.toSet());
                orderIdSet.removeAll(loadOrderIdList);
            }

            //所有需要预装的订单
            orderList = orderService.listByIds(orderIdSet);
            //关联关系拼接
            OrderTree orderTree = orderGuanlianService.getAllRelateOrderList(orderDO.getOrderNo(), orderRelationList);
            //2.有关联订单，首先列出来关联关系
            String relateMsg = orderTree.toString();
            sb.append(relateMsg);
        } else {
            orderList = Collections.singletonList(orderDO);
        }

        List<Integer> normalStatusList = Arrays.asList(5, 8, 9);
        //不符合条件的订单
        List<OrderDO> notMatchStatusList = orderList.stream()
                .filter(t -> !normalStatusList.contains(t.getStatus()))
                .collect(Collectors.toList());

        List<OrderDO> abnormalList = orderList.stream()
                .filter(t -> t.getAbnormalState() != 0)
                .collect(Collectors.toList());

        List<OrderDO> auditList = orderList.stream()
                .filter(t -> t.getAuditType() != 0)
                .collect(Collectors.toList());

        boolean isSuit = true;
        if (CollectionUtil.isNotEmpty(notMatchStatusList)) {
            isSuit = false;
            if (hasRelationOrder) {
                sb.append("<br>");
            }
            List<String> orderNoList = notMatchStatusList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            String orderNos = Joiner.on(",").join(orderNoList);
            sb.append("订单:").append(orderNos).append("不是已入仓状态，不能预装");
        }

        if (CollectionUtil.isNotEmpty(abnormalList)) {
            isSuit = false;
            if (hasRelationOrder) {
                sb.append("<br>");
            }
            List<String> orderNoList = abnormalList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            String orderNos = Joiner.on(",").join(orderNoList);
            sb.append("订单:").append(orderNos).append("存在异常");
        }

        if (CollectionUtil.isNotEmpty(auditList)) {
            isSuit = false;
            if (hasRelationOrder) {
                sb.append("<br>");
            }
            List<String> orderNoList = auditList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            String orderNos = Joiner.on(",").join(orderNoList);
            sb.append("订单:").append(orderNos).append("审核中");
        }

        if (!isSuit) {
            throw new ServiceException(500, sb.toString());
        }

        List<Long> orderIdList = orderList.stream()
                .map(OrderDO::getOrderId)
                .collect(Collectors.toList());

        //过滤了入仓为0的数据
        List<OrderItemBackVO> orderItemList = orderItemService.getOrderItemBackByOrderId(orderIdList);
        if (CollectionUtil.isEmpty(orderItemList)) {
            throw new ServiceException(500, "订单项不存在");
        }

        Set<Long> loadIdList = loadList.stream()
                .map(BoxPreloadGoodsDO::getOrderItemId)
                .collect(Collectors.toSet());

        //过滤掉已经预装的
        orderItemList = orderItemList.stream()
                .filter(t -> !loadIdList.contains(t.getOrderItemId()))
                .collect(Collectors.toList());

        List<Long> orderItemIdList = orderItemList.stream()
                .map(OrderItemBackVO::getOrderItemId)
                .collect(Collectors.toList());

        //1.校验订单项是否已预装
        checkInstallItem(loadList, orderItemIdList, orderList);

        //2.校验是否都预装都同一个部分
        checkInstallSection(secId, loadList, orderItemIdList);

        //3.检查仓库
        for (OrderDO item : orderList) {
            try {
                checkWarehouse(boxDO, item);
            } catch (Exception e) {
                isSuit = false;
                sb.append("订单:").append(item.getOrderNo()).append(",").append(e.getMessage()).append("<br>");
            }
        }
        if (!isSuit) {
            throw new ServiceException(500, sb.toString());
        }

        checkCabinet(boxDO, orderItemIdList);

        //都符合，预装，看是否弹出提示
        if (relationStatus == null || relationStatus == 1) {
            if (hasRelationOrder) {
                throw new ServiceException(566, sb.toString());
            }

        }

        List<BoxPreloadGoodsDO> preloadGoodsDOList = new ArrayList<>();
        for (OrderItemBackVO orderItem : orderItemList) {
            BoxPreloadGoodsDO boxPreloadGoods = BoxPreloadGoodsConvert.INSTANCE.convert(createReqVO);
            boxPreloadGoods.setOrderItemId(orderItem.getOrderItemId());
            boxPreloadGoods.setOrderId(orderItem.getOrderId());
            if (createReqVO.getIsCover() != null) {
                boxPreloadGoods.setIsCover(createReqVO.getIsCover());
            }
            preloadGoodsDOList.add(boxPreloadGoods);
        }
        // 插入
        boxPreloadGoodsMapper.insertBatch(preloadGoodsDOList);

        if (boxDO.getPrStatus() == PrStatusEnum.NO_PRELOAD.getPrStatus()) {
            //修改为预装中
            boxDO.setPrStatus(PrStatusEnum.PRELOAD_ING.getPrStatus());
            boxService.updateById(boxDO);
            for (Long oId : orderIdList) {
                boxService.updateOrderStatus(oId, null, null,
                        BoxStatusEnum.PREINSTALLING.getStatus(), null, null, Boolean.FALSE);
            }
            boxService.addOrderLog(orderIdList, OrderShipmentLog.PRELOAD_ADD, "");
        } else if (boxDO.getPrStatus() == PrStatusEnum.PRELOAD_APPROVAL_SUCCESS.getPrStatus()) {
            //补单。修改订单状态
            for (Long oId : orderIdList) {
                boxService.updateOrderStatus(oId, OrderStatusEnum.PRE_INSTALLED.getValue(), 0,
                        BoxStatusEnum.PREINSTALL_EXAMINE_SUCCESS.getStatus(), null, null, Boolean.FALSE);
            }
            //生成提单号
            boxService.generateBillLadingNo(shipmentId, false, false);
            boxService.addOrderLog(orderIdList, OrderShipmentLog.CABINET_PATCH, "");
        } else {
            for (Long oId : orderIdList) {
                boxService.updateOrderStatus(oId, null, null,
                        BoxStatusEnum.PREINSTALLING.getStatus(), null, null, Boolean.FALSE);
            }
            boxService.addOrderLog(orderIdList, OrderShipmentLog.PRELOAD_ADD, "");
        }

        //把自编号写入订单表
        for (Long oId : orderIdList) {
            boxService.updateOrderSelfNo(oId, boxDO.getSelfNo());
        }

        return new PreloadResultVO();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public PreloadResultVO createBoxPreloadGoods(BoxPreloadGoodsCreateReqVO createReqVO) {
        Long shipmentId = createReqVO.getShipmentId();

        //找到出货单
        BoxDO boxDO = boxService.getBox(shipmentId);
        if (boxDO == null) {
            throw exception(BOX_NOT_EXISTS);
        }

        boxService.checkApproval(shipmentId, null);

        Long orderId = createReqVO.getOrderId();
        Long secId = createReqVO.getSecId();
        List<Long> orderItemIdList = createReqVO.getOrderItemIdList();

        //过滤了入仓为0的数据
        List<OrderItemBackVO> orderItemList = orderItemService.getOrderItemBackByOrderId(Collections.singletonList(orderId));
        if (CollectionUtil.isNotEmpty(orderItemList)) {
            orderItemIdList = orderItemList.stream()
                    .map(OrderItemBackVO::getOrderItemId)
                    .collect(Collectors.toList());
        }

        //找到这个出货单已预装的商品
        List<BoxPreloadGoodsDO> loadList = baseMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
//            .in(BoxPreloadGoodsDO::getOrderItemId, orderItemIdList)
                        .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
                        .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        OrderDO orderDO = orderService.getById(orderId);

        //校验是否符合预装。
        checkInstallAvailable(boxDO, secId, loadList, orderDO, orderItemIdList);

        //如果都符合，下面展示互斥和关联订单的弹窗
        Integer relationStatus = createReqVO.getRelationStatus();
        //校验是否是互斥订单
        if (relationStatus == null || relationStatus == 2) {
            //校验互斥订单
            checkMutualOrder(loadList, orderDO);
        }

        //预装入库
        List<BoxPreloadGoodsDO> preloadGoodsDOList = new ArrayList<>();
        for (Long orderItemId : orderItemIdList) {
            BoxPreloadGoodsDO boxPreloadGoods = BoxPreloadGoodsConvert.INSTANCE.convert(createReqVO);
            boxPreloadGoods.setOrderItemId(orderItemId);
            if (createReqVO.getIsCover() != null) {
                boxPreloadGoods.setIsCover(createReqVO.getIsCover());
            }
            preloadGoodsDOList.add(boxPreloadGoods);
        }

        // 插入
        boxPreloadGoodsMapper.insertBatch(preloadGoodsDOList);

        if (boxDO.getPrStatus() == PrStatusEnum.NO_PRELOAD.getPrStatus()) {
            //修改为预装中
            boxDO.setPrStatus(PrStatusEnum.PRELOAD_ING.getPrStatus());
            boxService.updateById(boxDO);
            boxService.updateOrderStatus(orderId, null, null,
                    BoxStatusEnum.PREINSTALLING.getStatus(), null, null, Boolean.FALSE);
            boxService.addOrderLog(Collections.singletonList(orderId), OrderShipmentLog.PRELOAD_ADD, "");
        } else if (boxDO.getPrStatus() == PrStatusEnum.PRELOAD_APPROVAL_SUCCESS.getPrStatus()) {
            //补单。修改订单状态
            boxService.updateOrderStatus(orderId, OrderStatusEnum.PRE_INSTALLED.getValue(), 0,
                    BoxStatusEnum.PREINSTALL_EXAMINE_SUCCESS.getStatus(), null, null, Boolean.FALSE);

            //生成提单号
            boxService.generateBillLadingNo(shipmentId, false, false);

            boxService.addOrderLog(Collections.singletonList(orderId), OrderShipmentLog.CABINET_PATCH, "");
        } else {
            boxService.addOrderLog(Collections.singletonList(orderId), OrderShipmentLog.PRELOAD_ADD, "");
        }

        //把自编号写入订单表
        boxService.updateOrderSelfNo(orderId, boxDO.getSelfNo());

        PreloadResultVO preloadResultVO = new PreloadResultVO();

        //校验关联订单
        if (relationStatus == null || relationStatus == 1) {
            List<OrderDO> relationOrderList = checkRelationOrder(boxDO, secId, orderDO, orderItemIdList, loadList);
            if (CollectionUtil.isEmpty(relationOrderList)) return preloadResultVO;

            //需要弹窗提醒关联单
            List<String> orderNoList = relationOrderList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            List<Long> orderIdList = relationOrderList.stream()
                    .map(OrderDO::getOrderId)
                    .collect(Collectors.toList());

            String relationMsg = "订单" + orderDO.getOrderNo() +
                    "与" + Joiner.on(",").join(orderNoList) + "存在关联关系，请问是否要一起预装？";

            preloadResultVO.setRelationMsg(relationMsg);
            preloadResultVO.setOrderIdList(orderIdList);
            preloadResultVO.setShipmentId(shipmentId);
            preloadResultVO.setSecId(secId);
        }

        return preloadResultVO;
    }


    /**
     * 校验关联
     *
     * @param boxDO           出货单
     * @param secId           预装部分
     * @param orderDO         预装原始订单
     * @param orderItemIdList 原订单要预装的商品项
     * @param loadList        已预装的商品项
     */
    private List<OrderDO> checkRelationOrder(BoxDO boxDO, Long secId, OrderDO orderDO,
                                             List<Long> orderItemIdList, List<BoxPreloadGoodsDO> loadList) {
        //1.找出这个订单的关联订单ID列表
        Long orderId = orderDO.getOrderId();
        String transportType = boxDO.getTransportType();
        List<OrderGuanlianDO> guanlianList = orderGuanlianService.getGuanlianListByOrderId(orderId);
        if (CollectionUtil.isEmpty(guanlianList)) return null;

        //rIdList为此订单的所有关联订单
        List<Long> rIdList = new ArrayList<>();
        for (OrderGuanlianDO orderGuanlianDO : guanlianList) {
            Long oId = orderGuanlianDO.getOrderId();
            Long rId = orderGuanlianDO.getRelateOrderId();
            if (oId.equals(orderId)) {
                rIdList.add((rId));
            } else if (rId.equals(orderId)) {
                rIdList.add(oId);
            }
        }
        //找到所有符合预装条件的订单
        OrderPreloadReq orderPreloadReq = new OrderPreloadReq();
        orderPreloadReq.setTransportType(transportType);
        orderPreloadReq.setPageSize(Integer.MAX_VALUE);
        //TODO  优化，传参rdIdList
        BoxOrderPreloadStatistics boxOrderPreloadStatistics = orderPreloadPage(orderPreloadReq);
        PageResult<BoxOrderPreloadVo> pageResult = boxOrderPreloadStatistics.getDataList();
        List<BoxOrderPreloadVo> orderList = pageResult.getList();

        if (CollectionUtil.isEmpty(orderList)) return null;

        //找出符合条件的关联单
        orderList = orderList.stream()
                .filter(t -> rIdList.contains(t.getOrderId()))
                .collect(Collectors.toList());

        if (CollectionUtil.isEmpty(orderList)) return null;

        //剩下的就是符合条件的关联单
        //校验这些关联单是否可以和主订单一起合装
        List<OrderDO> relationOrderList = new ArrayList<>();

        for (BoxOrderPreloadVo boxOrderPreloadVo : orderList) {
            //关联单和主订单的订单项加在一起，
            Long rOrderId = boxOrderPreloadVo.getOrderId();
            //过滤了item sum = 0的数据
            List<OrderItemBackVO> orderAllItemList = orderItemService.getOrderItemBackByOrderId(Collections.singletonList(rOrderId));
//            List<OrderItemDO> orderAllItemList = orderItemService.getOrderItemsByOrderId(Collections.singletonList(rOrderId));

            List<Long> rOrderItemIdList = orderAllItemList.stream()
                    .map(OrderItemBackVO::getOrderItemId)
                    .collect(Collectors.toList());
//            rOrderItemIdList.addAll(orderItemIdList);
            OrderDO rOrderDO = boxService.getOrder(rOrderId);
            try {
                //校验是否校验一起装
                checkInstallAvailable(boxDO, secId, loadList, rOrderDO, rOrderItemIdList);
                //关联单预装成功，加入提醒
                relationOrderList.add(rOrderDO);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return relationOrderList;
    }

    /**
     * 校验互斥订单
     *
     * @param loadList 已装商品项
     * @param orderDO  想要预装的订单
     */
    private void checkMutualOrder(List<BoxPreloadGoodsDO> loadList, OrderDO orderDO) {
        //校验互斥订单,orderIdSet为已装的订单ID列表，互斥是校验已装的和想要预装的订单是否存在互斥
        Long orderId = orderDO.getOrderId();
        Set<Long> orderIdSet = loadList.stream()
                .map(BoxPreloadGoodsDO::getOrderId)
                .collect(Collectors.toSet());
        //已装为空，则不需要校验，
        if (CollectionUtil.isEmpty(orderIdSet)) return;

        orderIdSet.add(orderId);
        List<OrderDO> orderList = orderMutualService.searchMutualOrderList(orderId, orderIdSet);

        if (CollectionUtil.isEmpty(orderList)) return;

        //过滤自己
        orderList = orderList.stream().filter(t -> !t.getOrderId().equals(orderId)).collect(Collectors.toList());
        //过滤不在已装单里面的
        orderList = orderList.stream().filter(t -> orderIdSet.contains(t.getOrderId())).collect(Collectors.toList());

        if (CollectionUtil.isEmpty(orderList)) return;

        List<String> orderNoList = orderList.stream()
                .map(OrderDO::getOrderNo)
                .collect(Collectors.toList());

        throw new ServiceException(555, "当前预装订单" + orderDO.getOrderNo() +
                "与已预装订单" + Joiner.on(",").join(orderNoList) + "存在互斥关系，请问是否要继续预装吗？");
    }

    /**
     * 校验柜子体积重量
     *
     * @param boxDO           出货
     * @param orderItemIdList 订单项
     */
    private void checkCabinet(BoxDO boxDO, List<Long> orderItemIdList) {
        Long shipmentId = boxDO.getId();
        //校验体积
        BoxGoodsStatistics boxGoodsStatistics = calculationStatistics(shipmentId, null);

        //需要预装的商品
        List<OrderItemDO> orderItemDOList = orderItemService.getOrderItemList(orderItemIdList);

        //查找出这个出货单的箱子体积和重量
        CabinetDO cabinetDO = cabinetService.getCabinet(boxDO.getCabinetId());

        //计算剩余的体积和重量
        BigDecimal remainVolume = cabinetDO.getVolume().subtract(boxGoodsStatistics.getVolume()).setScale(2, BigDecimal.ROUND_DOWN);
        BigDecimal remainWeight = cabinetDO.getWeight().subtract(boxGoodsStatistics.getWeight()).setScale(2, BigDecimal.ROUND_DOWN);

        BoxGoodsStatistics reloadGoodsStatistics = calculationStatistics(orderItemDOList);
        if (remainVolume.compareTo(reloadGoodsStatistics.getVolume()) < 0) {
            throw exception(BOX_VOLUME_EXCEED);
        }
        if (remainWeight.compareTo(reloadGoodsStatistics.getWeight()) < 0) {
            throw exception(BOX_WEIGHT_EXCEED);
        }
    }

    /**
     * 校验仓库始发地、目的地是否符合要求
     *
     * @param boxDO   出货
     * @param orderDO 订单
     */
    private void checkWarehouse(BoxDO boxDO, OrderDO orderDO) {
        List<Long> warehouseIdList = new ArrayList<>();

        //1.校验始发地、目的地是否符合要求，在同一个国家则符合要求
        Long startWarehouseId = boxDO.getStartWarehouseId();
        Long destWarehouseId = boxDO.getDestWarehouseId();
        warehouseIdList.add(destWarehouseId);

        Long lineId = orderDO.getLineId();
        WarehouseLineDO lineDO = warehouseLineMapper.findOneIgnoreDeleted(lineId);
        Long orderStartWarehouseId = lineDO.getStartWarehouseId();
        Long orderDestWarehouseId = lineDO.getDestWarehouseId();

        warehouseIdList.add(orderDestWarehouseId);

        List<WarehouseDO> warehouseDOList = warehouseService.getByIdList(warehouseIdList);
        Map<Long, WarehouseDO> warehouseMap = warehouseDOList.stream()
                .collect(Collectors.toMap(WarehouseDO::getId, v -> v, (v1, v2) -> v2));
//
        WarehouseDO destWarehouseDO = warehouseMap.get(destWarehouseId);
        Long destCountryId = destWarehouseDO.getGuojia();
//
        WarehouseDO orderDestWarehouseDO = warehouseMap.get(orderDestWarehouseId);
        Long orderDestCountryId = orderDestWarehouseDO.getGuojia();

        //始发仓调仓后的目的仓
        Long adjustToDestWarehouseId = orderDO.getAdjustToDestWarehouseId();
        if (adjustToDestWarehouseId != null && adjustToDestWarehouseId != 0) {
            //调仓了，看出货仓库是否与调仓id一样
            if (!startWarehouseId.equals(adjustToDestWarehouseId)) {
                throw exception(BOX_WAREHOUSE_START_NOT_MATCH);
            }
        } else {
            //没有调仓，看出货仓库是否与订单仓库一样
            if (!startWarehouseId.equals(orderStartWarehouseId)) {
                throw exception(BOX_WAREHOUSE_START_NOT_MATCH);
            }
        }

        //目的地看国家是否一致
        if (!destCountryId.equals(orderDestCountryId)) {
            throw exception(BOX_WAREHOUSE_DEST_NOT_MATCH);
        }
    }

    /**
     * 校验同一个订单只能装在同一个部分
     *
     * @param secId              部分
     * @param loadList           已装
     * @param orderAllItemIdList 订单项
     */
    private void checkInstallSection(Long secId, List<BoxPreloadGoodsDO> loadList, List<Long> orderAllItemIdList) {
        //找到这些订单项在此装箱单中的部分
        Set<Long> sectionSets = loadList.stream()
                .filter(t -> orderAllItemIdList.contains(t.getOrderItemId()))
                .map(BoxPreloadGoodsDO::getSecId)
                .collect(Collectors.toSet());

        //有已装的部分，并且已装的部分和待装部分id不一致
        if (sectionSets.size() > 0 && !sectionSets.contains(secId)) {
            throw new ServiceException(500, "同一订单只能装在同一部分下");
        }
    }

    /**
     * 校验订单项是否已装
     *
     * @param loadList        已装
     * @param orderItemIdList 订单项
     */
    private void checkInstallItem(List<BoxPreloadGoodsDO> loadList, List<Long> orderItemIdList, List<OrderDO> orderList) {
        //订单项在系统的预装列表
        List<BoxPreloadGoodsDO> itemLoadList = list(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .in(BoxPreloadGoodsDO::getOrderItemId, orderItemIdList)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );

        if (CollectionUtil.isNotEmpty(itemLoadList)) {
            Set<Long> loadItemIdList = itemLoadList.stream()
                    .map(BoxPreloadGoodsDO::getOrderId)
                    .collect(Collectors.toSet());
            List<OrderDO> filterOrderList = orderList.stream()
                    .filter(t -> loadItemIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
            List<String> orderNoList = filterOrderList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            String loadItemIdStr = Joiner.on(",").join(orderNoList);
            throw new ServiceException(500, "订单(关联单):" + loadItemIdStr + "已被预装");
        }
    }


    /**
     * 校验订单预装是否可用
     *
     * @param boxDO           出货单
     * @param secId           需要预装在的部分
     * @param loadList        出货单已预装的商品项
     * @param orderDO         需要预装的订单
     * @param orderItemIdList 需要预装的商品项
     */
    private void checkInstallAvailable(BoxDO boxDO, Long secId,
                                       List<BoxPreloadGoodsDO> loadList,
                                       OrderDO orderDO,
                                       List<Long> orderItemIdList) {
        //订单校验是否在审核中
        Integer auditType = orderDO.getAuditType();
        if (auditType != 0) {
            throw exception(ORDER_HAS_PROCESSING_APPROVAL, orderDO.getOrderNo());
        }

        checkInstallItem(loadList, orderItemIdList, Collections.singletonList(orderDO));

        checkInstallSection(secId, loadList, orderItemIdList);

        checkWarehouse(boxDO, orderDO);

        checkCabinet(boxDO, orderItemIdList);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void loadRelationOrder(PreloadResultVO createReqVO) {
        //需要和createBoxPreloadGoods公用一个锁，防止并发导致预装多了

        Long shipmentId = createReqVO.getShipmentId();
        Long secId = createReqVO.getSecId();
        List<Long> orderIdList = createReqVO.getOrderIdList();
//        List<OrderItemDO> orderItemList = orderItemService.getOrderItemListByOrderIdList(orderIdList);
        //过滤了item sum = 0的数据
        List<OrderItemBackVO> orderItemList = orderItemService.getOrderItemBackByOrderId(orderIdList);
        List<BoxPreloadGoodsDO> preloadGoodsDOList = new ArrayList<>();
        for (OrderItemBackVO orderItemDO : orderItemList) {
            BoxPreloadGoodsDO boxPreloadGoods = new BoxPreloadGoodsDO();
            boxPreloadGoods.setShipmentId(shipmentId);
            boxPreloadGoods.setSecId(secId);
            boxPreloadGoods.setOrderId(orderItemDO.getOrderId());
            boxPreloadGoods.setOrderItemId(orderItemDO.getOrderItemId());
            preloadGoodsDOList.add(boxPreloadGoods);
        }
        // 插入
        boxPreloadGoodsMapper.insertBatch(preloadGoodsDOList);

        boxService.addOrderLog(orderIdList, OrderShipmentLog.PRELOAD_ADD, "关联单预装");

        BoxDO boxDO = boxService.getBox(shipmentId);
        orderIdList.forEach(t -> {
            boxService.updateOrderSelfNo(t, boxDO.getSelfNo());
        });

        //动态更新出货状态
        checkBoxPreLoadStatus(shipmentId);
    }

    /**
     * 统计已装的学校
     *
     * @param shipmentId 出货单ID
     * @param sectionId  部分ID,为空则统计所有
     * @return
     */
    private BoxGoodsStatistics calculationStatistics(Long shipmentId, Long sectionId) {
        BoxPreloadGoodsQueryVO queryVO = new BoxPreloadGoodsQueryVO();
        if (sectionId == null) {
            queryVO.setShipmentId(shipmentId);
        } else {
            queryVO.setSecId(sectionId);
        }
        queryVO.setIsRemove(0);
        List<BoxPreloadGoodsDO> goodsDOList = boxPreloadGoodsMapper.selectList(queryVO);
        //找出所有订单项
        List<Long> orderItemIdList = goodsDOList.stream()
                .map(BoxPreloadGoodsDO::getOrderItemId)
                .collect(Collectors.toList());
        List<OrderItemDO> orderItemDOList = new ArrayList<>();
        if (CollectionUtil.isNotEmpty(orderItemIdList)) {
            orderItemDOList = orderItemService.getOrderItemList(orderItemIdList);
        }
        return calculationStatistics(orderItemDOList);
    }

    @Override
    public BoxGoodsStatistics calculationStatistics(List<OrderItemDO> orderItemDOList) {
        List<OrderDO> orderDOList = getOrderListByOrderItem(orderItemDOList);
        BoxGoodsStatistics boxGoodsStatistics = calculationStatisticsByOrderList(orderDOList);
        //全部使用orderItem 计算。不需要calculationStatisticsByOrderList
        for (OrderItemDO orderItemDO : orderItemDOList) {
            BigDecimal chargeVolumeSum = boxGoodsStatistics.getChargeVolume();
            BigDecimal chargeWeightSum = boxGoodsStatistics.getChargeWeight();

            if (orderItemDO.getChargeVolume() != null) {
                chargeVolumeSum = chargeVolumeSum.add(orderItemDO.getChargeVolume()).setScale(2, BigDecimal.ROUND_DOWN);
                boxGoodsStatistics.setChargeVolume(chargeVolumeSum);
            }
            if (orderItemDO.getChargeWeight() != null) {
                chargeWeightSum = chargeWeightSum.add(orderItemDO.getChargeWeight()).setScale(2, BigDecimal.ROUND_DOWN);
                boxGoodsStatistics.setChargeWeight(chargeWeightSum);
            }
        }
        return boxGoodsStatistics;
    }

    private List<OrderDO> getOrderListByOrderItem(List<OrderItemDO> orderItemDOList) {
        if (CollectionUtils.isEmpty(orderItemDOList)) {
            return new ArrayList<>();
        }
        Set<Long> orderIdSet = orderItemDOList.stream()
                .map(OrderItemDO::getOrderId)
                .collect(Collectors.toSet());

        return orderQueryService.getOrderList(orderIdSet);
    }

    @Override
    public BoxGoodsStatistics calculationStatisticsByOrderList(
            Collection<OrderDO> orderDOList) {
        BoxGoodsStatistics boxGoodsStatistics = new BoxGoodsStatistics();
        if (CollectionUtil.isEmpty(orderDOList)) {
            return boxGoodsStatistics;
        }
        for (OrderDO orderDO : orderDOList) {
            long numSum = boxGoodsStatistics.getNum();
            BigDecimal volumeSum = boxGoodsStatistics.getVolume();
            BigDecimal weightSum = boxGoodsStatistics.getWeight();

            if(orderDO!=null) {
                if (orderDO.getSumNum() != null) {
                    numSum += orderDO.getSumNum();
                    boxGoodsStatistics.setNum(numSum);
                }
                if (orderDO.getSumVolume() != null) {
                    volumeSum = volumeSum.add(orderDO.getSumVolume()).setScale(2, BigDecimal.ROUND_DOWN);
                    boxGoodsStatistics.setVolume(volumeSum);
                }
                if (orderDO.getSumWeight() != null) {
                    weightSum = weightSum.add(orderDO.getSumWeight()).setScale(2, BigDecimal.ROUND_DOWN);
                    boxGoodsStatistics.setWeight(weightSum);
                }
            }
        }
        return boxGoodsStatistics;
    }

    @Override
    public void delCheckStatus(Long shipmentId) {
        //>审核中就不可以移出,
        BoxDO boxDO = boxService.getBox(shipmentId);
        if (boxDO.getTransportType().equals(TransportTypeEnum.AIR.getType())) {
            Integer airShipmentStatus = boxDO.getAirShipmentStatus();
            if (airShipmentStatus == AirShipmentStatusEnum.SHIPMENT.getStatus()) {
                throw new ServiceException(500, "自编号通过出货审核，无法删除订单");
            }
        } else {
            Integer ldStatus = boxDO.getLdStatus();
            if (ldStatus == LdStatusEnum.INSTALLED_TO_BE_SEALED.getLdStatus() || ldStatus == LdStatusEnum.CABINET_EXAMINE_ING.getLdStatus()
                    || ldStatus == LdStatusEnum.CABINET_EXAMINE_SUCCESS.getLdStatus() || ldStatus == LdStatusEnum.CABINET_SEALED.getLdStatus()) {
                throw new ServiceException(500, "自编号通过出货审核，无法删除订单");
            }
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void deleteBoxPreloadGoods(Collection<Long> ids, Integer deleteType) {
        //同时删除这些商品的订单下的所有商品
        List<BoxPreloadGoodsDO> goodItemList = getBoxPreloadGoodsList(ids);
        if (CollectionUtil.isEmpty(goodItemList)) return;

        //校验是否在审核中
        BoxPreloadGoodsDO boxPreloadGoodsDO = goodItemList.get(0);
        Long shipmentId = boxPreloadGoodsDO.getShipmentId();
        boxService.checkApproval(shipmentId, null);

        delCheckStatus(shipmentId);

        Collection<Long> orderIdSet = goodItemList.stream()
                .map(BoxPreloadGoodsDO::getOrderId)
                .collect(Collectors.toSet());

        //处理需要删除的关联单
        orderIdSet = checkDeleteOrder(shipmentId, deleteType, orderIdSet);

        deleteOrderList(shipmentId, orderIdSet, 1, false);

        boxService.addOrderLog(new ArrayList<>(orderIdSet), OrderShipmentLog.PRELOAD_REMOVE, "");

        //动态更新出货状态
        checkBoxPreLoadStatus(shipmentId);
    }

    @Override
    public Collection<Long> checkDeleteOrder(Long shipmentId, Integer deleteType, Collection<Long> orderIdList) {
        if (deleteType == null) {
            //需要弹窗提示
            //找出这些订单的关联单,提示
            BoxOrderRemoveAO ao = findRelationOrder(shipmentId, orderIdList);
            if (ao.isHasRelationOrder()) {
                //有关联单，弹出提示
                throw new ServiceException(666, ao.getMsg());
            }
        } else {
            //需要删除关联单
            if (deleteType == 2) {
                BoxOrderRemoveAO ao = findRelationOrder(shipmentId, orderIdList);
                if (ao.isHasRelationOrder()) {
                    List<OrderDO> orderList = ao.getRemoveList();
                    orderIdList = orderList.stream()
                            .map(OrderDO::getOrderId)
                            .collect(Collectors.toSet());
                }
            }
        }
        return orderIdList;
    }

    private BoxOrderRemoveAO findRelationOrder(Long shipmentId, Collection<Long> orderIdList) {
        BoxOrderRemoveAO ao = new BoxOrderRemoveAO();
        boolean relationOrder = false;

        StringBuilder sb = new StringBuilder();
        List<OrderDO> orderList = new ArrayList<>();
        ao.setRemoveList(orderList);
        if (CollectionUtil.isNotEmpty(orderIdList)) {
            List<OrderDO> removeOrderList = orderService.listByIds(orderIdList);
            Map<Long, OrderDO> orderMap = removeOrderList.stream()
                    .collect(Collectors.toMap(OrderDO::getOrderId, v -> v, (v1, v2) -> v2));

            //找出这个出货所有预装的订单
            Set<Long> preloadOrderIdSet = getShipOrderIdList(shipmentId);

            for (Long orderId : orderIdList) {
                OrderDO orderDO = orderMap.get(orderId);

                //订单的所有关联单
                List<OrderGuanlianDO> orderRelationList = orderGuanlianService.getRelationList(orderId);
                if (orderRelationList != null) {
                    //过滤掉不在这个出货的关联单
                    orderRelationList = orderRelationList.stream()
                            .filter(t -> preloadOrderIdSet.contains(t.getOrderId()) && preloadOrderIdSet.contains(t.getRelateOrderId()))
                            .collect(Collectors.toList());
                }
                boolean hasRelationOrder = CollectionUtil.isNotEmpty(orderRelationList);
                if (hasRelationOrder) {
                    //从已经预装的里面过滤
                    orderRelationList = orderRelationList.stream()
                            .filter(t -> preloadOrderIdSet.contains(t.getOrderId()) || preloadOrderIdSet.contains(t.getRelateOrderId()))
                            .collect(Collectors.toList());
                    if (CollectionUtils.isEmpty(orderRelationList)) continue;

                    relationOrder = true;

                    Set<Long> orderIdSet = orderRelationList.stream()
                            .flatMap(o -> Stream.of(o.getOrderId(), o.getRelateOrderId()))
                            .collect(Collectors.toSet());
                    //所有需要预装的订单
                    List<OrderDO> deleteList = orderService.listByIds(orderIdSet);
                    orderList.addAll(deleteList);

                    //所有需要预装的订单
                    OrderTree orderTree = orderGuanlianService.getAllRelateOrderList(orderDO.getOrderNo(), orderRelationList);
                    sb.append(orderTree.toString());
                    sb.append("<br>");
                } else {
                    orderList.add(orderDO);
                }
            }
        }
        ao.setMsg(sb.toString());
        ao.setHasRelationOrder(relationOrder);
        return ao;
    }

    @Override
    public BoxPreloadGoodsDO getBoxPreloadGoods(Long id) {
        return boxPreloadGoodsMapper.selectById(id);
    }

    @Override
    public List<BoxPreloadGoodsDO> getBoxPreloadGoodsList(Collection<Long> ids) {
        return boxPreloadGoodsMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<BoxPreloadGoodsDO> getBoxPreloadGoodsPage(BoxPreloadGoodsQueryVO query, PageVO page) {
        return boxPreloadGoodsMapper.selectPage(page, query);
    }

    @Override
    public List<BoxPreloadGoodsDO> getBoxPreloadGoodsList(BoxPreloadGoodsQueryVO query) {
        return boxPreloadGoodsMapper.selectList(query);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public BoxPreloadSectionDetailVO getBoxPreloadSectionList(PreloadedReq query) {
        Long shipmentId = query.getShipmentId();
        query.setLang(I18nMessage.getLang());
        boxService.generateBillLadingNo(shipmentId, false, true);

        BoxDO boxDO = boxService.getBox(shipmentId);

        List<BoxPreloadSectionDO> sectionList =
                boxPreloadSectionService.selectList("shipment_id", shipmentId);
        if (CollectionUtil.isEmpty(sectionList)) {
//            sectionList = new ArrayList<>();
//

            //智慧预装
            DictDataExportReqVO dictDataExportReqVO = new DictDataExportReqVO();
            dictDataExportReqVO.setDictType("part_function_switch");
            List<DictDataDO> dictDataRespDTOS = dictDataService.getDictDatas(dictDataExportReqVO);
            if (query.getSmartInstall() != null && query.getSmartInstall() == 1) {
                int defaultNum = 5;
                if (boxDO.getTransportType().equals(TransportTypeEnum.AIR.getType())) {
                    defaultNum = 1;
                }
                //默认创建5个部分
                for (int i = 0; i < defaultNum; i++) {
                    BoxPreloadSectionDO sectionDO = new BoxPreloadSectionDO();
                    sectionDO.setShipmentId(shipmentId);
                    sectionList.add(sectionDO);
                }
                boxPreloadSectionService.insertBatch(sectionList);
                if (!CollectionUtils.isEmpty(dictDataRespDTOS) && "1".equals(dictDataRespDTOS.get(0).getValue())) {
                    smartInstall(boxDO, sectionList);
                }
            }
        } else {
            sectionList.sort(Comparator.comparing(BoxPreloadSectionDO::getId));
        }

        //预装，查询的要过滤装柜里面补单的
//        query.setIsCover(0);
        query.setIsRemove(0);
        List<BoxPreloadGoodsBackVO> goodsItemList = boxPreloadGoodsMapper.orderPreloaded(query);


        Map<Long, List<BoxPreloadGoodsBackVO>> sectionGoodsMap = goodsItemList.stream()
                .collect(Collectors.groupingBy(BoxPreloadGoodsBackVO::getSecId));
        List<BoxPreloadSectionBackVO> sectionBackList = BoxPreloadSectionConvert.INSTANCE.convertList(sectionList);

        List<ProductAttrDO> productAttrDOList = productAttrService.getProductAttrList();
        Map<String, String> idNameMap = productAttrDOList.stream()
                .collect(Collectors.toMap(attr -> String.valueOf(attr.getId()), ProductAttrDO::getAttrName));


        List<OrderItemDO> allItemDOList = new ArrayList<>();
        for (BoxPreloadSectionBackVO sectionBackVO : sectionBackList) {
            List<BoxPreloadGoodsBackVO> sectionGoodsList = sectionGoodsMap.get(sectionBackVO.getId());
            sectionBackVO.setSectionGoodsList(sectionGoodsList);

            if (sectionGoodsList == null) continue;

            for (BoxPreloadGoodsBackVO boxPreloadGoodsBackVO : sectionGoodsList) {
                boxPreloadGoodsBackVO.setAttrNameList(
                        getAttrNameByIds(boxPreloadGoodsBackVO.getProdAttrIds(), idNameMap)
                );
                boxPreloadGoodsBackVO.setWarehouseInAttrNameList(
                        getAttrNameByIds(boxPreloadGoodsBackVO.getWarehouseInProdAttrIds(), idNameMap)
                );
            }

            List<OrderItemDO> orderItemDOList = convertOrderItemList(sectionGoodsList);

            allItemDOList.addAll(orderItemDOList);

            //统计
            BoxGoodsStatistics boxGoodsStatistics = calculationStatistics(orderItemDOList);
            sectionBackVO.setSecStatistics(boxGoodsStatistics);
        }
        //已装载的统计
        BoxGoodsStatistics loadStatistics = calculationStatistics(allItemDOList);

        //剩余的
        //查找出这个出货单的箱子体积和重量
        CabinetDO cabinetDO = cabinetService.getCabinet(boxDO.getCabinetId());
        BoxPreloadSectionDetailVO data = new BoxPreloadSectionDetailVO();
        data.setLoadStatistics(loadStatistics);
        data.setSectionGoodList(sectionBackList);
        if (cabinetDO != null) {
            //计算剩余的体积和重量
            BigDecimal remainVolume = cabinetDO.getVolume().subtract(loadStatistics.getVolume()).setScale(2, BigDecimal.ROUND_DOWN);
            BigDecimal remainWeight = cabinetDO.getWeight().subtract(loadStatistics.getWeight()).setScale(2, BigDecimal.ROUND_DOWN);
            data.setRemainVolume(remainVolume);
            data.setRemainWeight(remainWeight);
        }
        return data;
    }

    /**
     * 智慧预装
     * 按入仓时间最早、路线相同、方数符合要求的订单默认填充，可手动移出。
     * 1.优先拆单、报关退场订单
     * <p>
     * 预装规则：
     * 第一部分：存放柜里货
     * 第二部分：在非柜里货中筛选存在有牌的货，装在第二部分
     * 第三部分：无牌的柜内货
     * 第四部分：无牌的次封柜货
     * 第五部分：无牌的封柜货
     *
     * @param boxDO 出货单
     */
    private void smartInstall(BoxDO boxDO, List<BoxPreloadSectionDO> sectionList) {


        //始发仓
        Long startWarehouseId = boxDO.getStartWarehouseId();
        //目的仓
        Long destWarehouseId = boxDO.getDestWarehouseId();
        //运输方式
        String transportType = boxDO.getTransportType();
        //出货渠道
        Long shippingChannelId = boxDO.getShippingChannelId();
        Long shipmentId = boxDO.getId();

        //找出所有符合条件的未预装订单
        OrderPreloadReq orderPreloadReq = new OrderPreloadReq();
        orderPreloadReq.setStartWarehouseId(startWarehouseId);
        orderPreloadReq.setDestWarehouseIdList(Collections.singletonList(destWarehouseId));
        orderPreloadReq.setTransportType(transportType);
        orderPreloadReq.setPageSize(Integer.MAX_VALUE);
        BoxOrderPreloadStatistics boxOrderPreloadStatistics = orderPreloadPage(orderPreloadReq);
        PageResult<BoxOrderPreloadVo> pageResult = boxOrderPreloadStatistics.getDataList();
        if (pageResult == null) return;

        List<BoxOrderPreloadVo> orderList = pageResult.getList();

        if (CollectionUtil.isEmpty(orderList)) return;

        //首先按照入仓时间排序
        orderList.sort((o1, o2) -> o2.getRucangTime().compareTo(o1.getRucangTime()));

        //排序，拆单的排在前面，退场的无法判断
        orderList.sort(Comparator.comparing(OrderPreloadVO::getParentOrderId));

        List<Long> orderIdList = orderList.stream()
                .map(OrderPreloadVO::getOrderId)
                .collect(Collectors.toList());

        //找出这些订单的订单项
        List<OrderItemDO> orderItemList = boxService.getOrderItemListByOrderIdList(orderIdList);


        Map<Long, List<OrderItemDO>> orderItemMap = orderItemList.stream()
                .collect(Collectors.groupingBy(OrderItemDO::getOrderId));

        //找到这些订单项的商品
//        Set<Long> proIdSet = orderItemList.stream()
//                .map(OrderItemDO::getProdId)
//                .collect(Collectors.toSet());
//        List<ProductDO> productList = boxService.getProductList(proIdSet);
//        Map<Long, ProductDO> productMap = productList.stream()
//                .collect(Collectors.toMap(ProductDO::getId, t -> t));

        for (BoxOrderPreloadVo orderPreloadVo : orderList) {
            Long orderId = orderPreloadVo.getOrderId();
            List<OrderItemDO> itemOrderItemList = orderItemMap.get(orderId);
            Integer sectionPosition = checkSectionPosition(itemOrderItemList);
            //
            if (sectionPosition == null) continue;
            BoxPreloadSectionDO sectionDO;
            int sectionSize = sectionList.size();
            if (sectionSize > sectionPosition) {
                sectionDO = sectionList.get(sectionPosition);
            } else {
                int needAdd = (sectionPosition + 1) - sectionSize;
                List<BoxPreloadSectionDO> needAddList = new ArrayList<>();
                for (int i = 0; i < needAdd; i++) {
                    BoxPreloadSectionDO sectionItem = new BoxPreloadSectionDO();
                    sectionItem.setShipmentId(shipmentId);
                    needAddList.add(sectionItem);
                }
                boxPreloadSectionService.insertBatch(needAddList);
                sectionDO = needAddList.get(needAddList.size() - 1);
                sectionList.addAll(needAddList);
            }

            BoxPreloadGoodsCreateReqVO createReq = new BoxPreloadGoodsCreateReqVO();
            createReq.setShipmentId(shipmentId);
            createReq.setSecId(sectionDO.getId());
            createReq.setOrderId(orderId);
            //不校验互斥和关联
            createReq.setRelationStatus(3);
            List<Long> orderItemIdList = itemOrderItemList.stream()
                    .map(OrderItemDO::getOrderItemId)
                    .collect(Collectors.toList());
            createReq.setOrderItemIdList(orderItemIdList);
            try {
                createBoxPreloadGoods(createReq);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

    }

    //计算订单放在部分的位置

    /**
     * 第一部分：存放柜里货
     * 第二部分：在非柜里货中筛选存在有牌的货，装在第二部分
     * 第三部分：无牌的柜内货
     * 第四部分：无牌的次封柜货
     * 第五部分：无牌的封柜货
     *
     * @param itemOrderItemList 订单项
     * @return
     */
    private Integer checkSectionPosition(List<OrderItemDO> itemOrderItemList) {
        for (OrderItemDO orderItemDO : itemOrderItemList) {
            Long proId = orderItemDO.getProdId();
            Long lineId = orderItemDO.getLineId();
            Long channelId = orderItemDO.getChannelId();
            if (channelId == null) channelId = 0L;
            ProductPriceDO productPriceDO = boxService.getProductPrice(proId, lineId, channelId);
            String containerLocation = productPriceDO.getContainerLocation();
            if (StringUtils.isEmpty(containerLocation)) {
                //未设置的话，默认为柜里货
                containerLocation = ContainerLocation.GLH.getValue();
            }

            Integer brandType = orderItemDO.getBrandType();

            if (containerLocation.equals(ContainerLocation.GLH.getValue())) {
                //柜里货,放第一部分
                return 0;
            } else {
                //有牌，放在第二部分
                if (brandType == 1) {
                    return 1;
                } else {
                    //
                    if (containerLocation.equals(ContainerLocation.GNH.getValue())) {
                        return 2;
                    } else if (containerLocation.equals(ContainerLocation.CFHG.getValue())) {
                        return 3;
                    } else if (containerLocation.equals(ContainerLocation.FHG.getValue())) {
                        return 4;
                    }
                }
            }
        }
        return null;
    }

    /**
     * 获取部分列表
     *
     * @param shipmentId 出货单ID
     * @return
     */
    private List<BoxPreloadSectionDO> getSectionListByShipmentId(Long shipmentId) {
        List<BoxPreloadSectionDO> sectionList = boxPreloadSectionService.selectList("shipment_id", shipmentId);
        sectionList.sort(Comparator.comparing(BoxPreloadSectionDO::getId));
        return sectionList;
    }

    @Override
    public void generateBillLadingNo(Long shipmentId, boolean updateOrder, boolean tempSort) {
        //找出这个出货单的所有预装商品
        List<BoxPreloadGoodsDO> preloadGoodsList = list(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
        );

        //首先判断是否是反审后回来的
        BoxApprovalDO boxApprovalDO = boxService.getLatestApproval(shipmentId);
        if (boxApprovalDO != null) {
            boolean backApproval = boxApprovalDO.getApprovalType() == BoxApprovalTypeEnum.PRELOAD_UMPIRE.getType()
                    || boxApprovalDO.getApprovalType() == BoxApprovalTypeEnum.AIR_SORTING_BACK.getType();
            if (backApproval) tempSort = false;
        }

        int maxNum = 0;
        if (!tempSort) {
            List<BoxPreloadGoodsDO> settleList = preloadGoodsList.stream().
                    filter(t -> t.getTidanNum() != 99999)
                    .collect(Collectors.toList());
            OptionalInt optionalInt = settleList.stream().mapToInt(BoxPreloadGoodsDO::getTidanNum).max();
            if (optionalInt.isPresent()) {
                maxNum = optionalInt.getAsInt();
            }

        }

        BoxDO boxDO = boxService.getBox(shipmentId);
        String selfNo = boxDO.getSelfNo();

        //过滤已经移出的
        preloadGoodsList = preloadGoodsList.stream()
                .filter(t -> t.getIsRemove() == 0)
                .collect(Collectors.toList());

        //还未设置提单号
        if (maxNum == 0) {
            List<BoxPreloadSectionDO> sectionList = getSectionListByShipmentId(shipmentId);

            Map<Long, List<BoxPreloadGoodsDO>> sectionGoodsMap = preloadGoodsList.stream()
                    .collect(Collectors.groupingBy(BoxPreloadGoodsDO::getSecId));

            int orderNum = 1;
            for (BoxPreloadSectionDO sectionDO : sectionList) {
                List<BoxPreloadGoodsDO> sectionGoodsList = sectionGoodsMap.get(sectionDO.getId());
                if (CollectionUtil.isEmpty(sectionGoodsList)) continue;
                sectionGoodsList.sort(Comparator.comparing(BoxPreloadGoodsDO::getId));
                orderNum = setTidanNum(sectionGoodsList, orderNum, selfNo, updateOrder);

            }
            updateBatch(preloadGoodsList);

        } else {
            //反审后的，只用给补单的补上提单号
            List<BoxPreloadGoodsDO> list = preloadGoodsList.stream()
                    .filter(t -> t.getTidanNum() == 99999)
                    .collect(Collectors.toList());
            if (CollectionUtil.isNotEmpty(list)) {
                //按照时间排序
                list.sort(Comparator.comparing(BaseDO::getCreateTime));

                int orderNum = maxNum + 1;

                List<Integer> missList = findDeletionList(preloadGoodsList);
                if (CollectionUtil.isEmpty(missList)) {
                    orderNum = setTidanNum(list, orderNum, selfNo, updateOrder);
                } else {
                    //list是需要补单的数据
                    Map<Long, List<BoxPreloadGoodsDO>> orderMap = list.stream()
                            .collect(Collectors.groupingBy(
                                    BoxPreloadGoodsDO::getOrderId,
                                    LinkedHashMap::new,
                                    Collectors.toList()
                            ));
                    Iterator<Long> orderIdIt = orderMap.keySet().iterator();
                    for (Integer num : missList) {
                        if(orderIdIt.hasNext()) {
                            Long orderId = orderIdIt.next();
                            List<BoxPreloadGoodsDO> orderGoodList = orderMap.get(orderId);
                            setTidanNum(orderGoodList, num, selfNo, updateOrder);
                            orderIdIt.remove();
                        }
                    }
                    //如果还有，则继续往后加
                    List<BoxPreloadGoodsDO> resultList = orderMap.values().stream()
                            .flatMap(Collection::stream)
                            .collect(Collectors.toList());
                    if(CollectionUtil.isNotEmpty(resultList)) {
                        setTidanNum(resultList, orderNum, selfNo, updateOrder);
                    }
                }
                updateBatch(list);
            }
        }

        if(updateOrder) {
            Set<Long> orderIdSet = preloadGoodsList.stream()
                    .map(BoxPreloadGoodsDO::getOrderId)
                    .collect(Collectors.toSet());

            Map<Long, Integer> tidanNumMap = preloadGoodsList.stream()
                    .collect(Collectors.toMap(BoxPreloadGoodsDO::getOrderId, BoxPreloadGoodsDO::getTidanNum, (v1, v2)->v2));
            for (Long orderId : orderIdSet) {
                Integer orderNum = tidanNumMap.get(orderId);
                String ladingBillNo = selfNo + "-" + orderNum;
                orderService.updateLadingBillNo(orderId, ladingBillNo);
            }
        }
    }

    /**
     * 找出有间隔的订单
     * @param list  预装商品项
     * @return
     */
    private List<Integer> findDeletionList(List<BoxPreloadGoodsDO> list) {
        List<BoxPreloadGoodsDO> preloadGoodsDOList = list.stream()
                .filter(t -> t.getTidanNum() != 99999)
                .collect(Collectors.toList());

        List<Integer> tidanList = preloadGoodsDOList.stream()
                .map(BoxPreloadGoodsDO::getTidanNum)
                .distinct() // 去重
                .sorted() // 排序
                .collect(Collectors.toList());

        int maxNum = tidanList.stream().max(Integer::compareTo).orElse(1);

        List<Integer> missingList = new ArrayList<>();
        for (int number = 1; number < maxNum; number++) {
            if (!tidanList.contains(number)) {
                missingList.add(number);
            }
        }
        return missingList;
    }

    private int setTidanNum(List<BoxPreloadGoodsDO> preloadGoodsList, int orderNum, String selfNo, boolean updateOrder) {
        Map<Long, Integer> orderNumMap = new HashMap<>();

        //按照订单分组
        for (BoxPreloadGoodsDO  preloadGoodsDO : preloadGoodsList) {
            Long orderId = preloadGoodsDO.getOrderId();
            int finalOrderNum = orderNum;
            if (orderNumMap.containsKey(orderId)) {
                finalOrderNum = orderNumMap.get(orderId);
            } else {
                orderNumMap.put(orderId, finalOrderNum);
                orderNum++;
            }
            preloadGoodsDO.setTidanNum(finalOrderNum);
        }


//        Map<Long, List<BoxPreloadGoodsDO>> orderItemsMap = preloadGoodsList.stream()
//                .collect(Collectors.groupingBy(BoxPreloadGoodsDO::getOrderId));
//
//        for (Map.Entry<Long, List<BoxPreloadGoodsDO>> entry : orderItemsMap.entrySet()) {
//            Long orderId = entry.getKey();
//            List<BoxPreloadGoodsDO> itemPreloadList = entry.getValue();
//            int finalOrderNum = orderNum;
//            itemPreloadList.forEach(t -> t.setTidanNum(finalOrderNum));
//            String ladingBillNo = selfNo + "-" + orderNum;
//            if(updateOrder) {
//                orderService.updateLadingBillNo(orderId, ladingBillNo);
//            }
//            orderNum++;
//        }
        return orderNum;
    }

    /**
     * 根据订单生成提单号
     * @param orderId  订单ID
     * @return
     */
    public String getLadingBillNo(Long orderId) {
        List<BoxPreloadGoodsDO> goodsDOList = baseMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getOrderId, orderId)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        if (CollectionUtil.isEmpty(goodsDOList)) {
            throw new IllegalStateException("出货单不存在");
        }
        BoxPreloadGoodsDO boxPreloadGoodsDO = goodsDOList.get(0);
        Long shipmentId = boxPreloadGoodsDO.getShipmentId();
        BoxDO boxDO = boxService.getBox(shipmentId);

        int tidanNum = boxPreloadGoodsDO.getTidanNum();

        return boxDO.getSelfNo() + "-" + tidanNum;
    }

    @Override
    public List<BoxLoadSectionBackVO> loadSecGoodsList(Long shipmentId) {
        List<BoxPreloadSectionDO> sectionList = getSectionListByShipmentId(shipmentId);
        List<BoxLoadSectionBackVO> dataList = new ArrayList<>();

        for (BoxPreloadSectionDO sectionDO : sectionList) {
            Long secId = sectionDO.getId();
            BoxLoadDetailBackVO secDetail = boxGoodsList(shipmentId, secId, null, 0);
            dataList.add(createBoxSecDetail(secDetail, shipmentId, sectionDO));
        }
        return dataList;
    }

    @Override
    public Set<Long> getShipOrderIdList(Long shipmentId) {
        //1.获取出货单下的所有订单ID
        List<BoxPreloadGoodsBackVO> goodsDOList = getShipGoodItemList(shipmentId);
        return goodsDOList.stream()
                .map(BoxPreloadGoodsBackVO::getOrderId)
                .collect(Collectors.toSet());
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void deleteBoxPreloadSection(Long id, Integer deleteType) {
        //校验是否在审核中
        BoxPreloadSectionDO sectionDO = boxPreloadSectionService.getById(id);
        Long shipmentId = sectionDO.getShipmentId();
        boxService.checkApproval(shipmentId, null);

        delCheckStatus(shipmentId);

        //找到这个section下所有的订单
        List<BoxPreloadGoodsDO> goodItemList = boxPreloadGoodsMapper.selectList(new LambdaQueryWrapper<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getSecId, id)
        );

        Collection<Long> orderIdSet = goodItemList.stream()
                .map(BoxPreloadGoodsDO::getOrderId)
                .collect(Collectors.toSet());

        boxPreloadSectionService.deleteBoxPreloadSection(id);

        orderIdSet = checkDeleteOrder(shipmentId, deleteType, orderIdSet);

        deleteOrderList(shipmentId, orderIdSet, 1, false);

        boxService.addOrderLog(new ArrayList<>(orderIdSet), OrderShipmentLog.PRELOAD_REMOVE, "删除部分");

        //动态更新出货状态
        checkBoxPreLoadStatus(shipmentId);
    }

    //检查出货有没有预装订单，修改出货的状态，预装中还是已订舱，待预装
    private void checkBoxPreLoadStatus(Long shipmentId) {
        BoxDO boxDO = boxService.getBox(shipmentId);
        Integer prStatus = boxDO.getPrStatus();
        Set<Long> orderIdSet = getShipOrderIdList(shipmentId);
        if(CollectionUtil.isEmpty(orderIdSet)) {
            if(prStatus == PrStatusEnum.PRELOAD_ING.getPrStatus() ||
                    prStatus == PrStatusEnum.PRELOAD_APPROVAL_FAIL.getPrStatus()
            ) {
                //修改为已订舱，待预装
                boxDO.setPrStatus(PrStatusEnum.NO_PRELOAD.getPrStatus());
                boxDO.setBkStatus(BookStatusEnum.BOOKED.getBkStatus());
            }
        } else {
            //修改为预装中
            if(prStatus == PrStatusEnum.NO_PRELOAD.getPrStatus() ||
                    prStatus == PrStatusEnum.PRELOAD_APPROVAL_FAIL.getPrStatus()
            ) {
                //未预装和预装审核失败的情况才修改为预装中
                boxDO.setPrStatus(PrStatusEnum.PRELOAD_ING.getPrStatus());
            }

        }
        boxService.updateById(boxDO);
    }

    /**
     * 把订单从出货单中删除
     * @param shipmentId  出货单ID
     * @param orderIdCollection  订单列表
     * @param type  1 预装移除 2 理货移除 3 装柜移除
     * @param hasExit  是否退场
     */
    @Override
    public void deleteOrderList(Long shipmentId, Collection<Long> orderIdCollection, Integer type, boolean hasExit) {
        if(CollectionUtil.isNotEmpty(orderIdCollection)) {
            //删除装柜商品
            boxPreloadGoodsMapper.delete(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                    .in(BoxPreloadGoodsDO::getOrderId, orderIdCollection)
                    .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
            );
            //删除已经装柜的标签
            boxLoadInfoService.deleteLoadInfo(shipmentId, new ArrayList<>(orderIdCollection));

            //删除合包箱
            pkgOrderService.deleteRelateByOrderIds(shipmentId, new ArrayList<>(orderIdCollection));

            //订单日志回退
            BoxDO boxDO = boxService.getById(shipmentId);
            //异步更新订单状态和删除订单提单号、提单文件
            boxService.asyncRemoveOrder(orderIdCollection, type, hasExit, boxDO.getTransportType());

            //删除该订单在理货这合包时的装箱数据
            boxOrderCheckInfoService.remove(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
                    .eq(BoxOrderCheckInfoDO::getShipmentId,shipmentId)
                    .in(BoxOrderCheckInfoDO::getOrderId,orderIdCollection)
            );

            //删除已经理货的数据
            boxTallyService.remove(new LambdaQueryWrapper<BoxTallyDO>()
                .eq(BoxTallyDO::getShipmentId, shipmentId)
                    .in(BoxTallyDO::getOrderId, orderIdCollection)
            );
        }
    }

    @Override
    public void changeSection(PreloadChange params) {
        BoxPreloadGoodsDO boxPreloadGoodsDO = boxPreloadGoodsMapper.selectById(params.getId());
//        boxPreloadGoodsDO.setSecId(params.getSecId());

        //校验是否在审核中
        boxService.checkApproval(boxPreloadGoodsDO.getShipmentId(), null);


        BoxPreloadGoodsDO updateDO = new BoxPreloadGoodsDO();
        updateDO.setSecId(params.getSecId());
        //修改订单下所有商品的部分
        boxPreloadGoodsMapper.update(updateDO, new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getShipmentId, boxPreloadGoodsDO.getShipmentId())
                .eq(BoxPreloadGoodsDO::getOrderId, boxPreloadGoodsDO.getOrderId())
        );
//        boxPreloadGoodsMapper.updateById(boxPreloadGoodsDO);
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public void removeBox(Long shipmentId, Long orderId) {
        BoxPreloadGoodsDO goodsDO = new BoxPreloadGoodsDO();
        goodsDO.setIsRemove(1);
        boxPreloadGoodsMapper.update(goodsDO, new LambdaQueryWrapper<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
                .eq(BoxPreloadGoodsDO::getOrderId, orderId)
        );
    }

    @Override
    public BoxLoadDetailBackVO boxGoodsList(Long shipmentId, Long secId, Integer isCover, Integer isRemove) {
        return boxGoodsList(shipmentId, secId, isCover, isRemove, null);
    }

    @Override
    public BoxLoadDetailBackVO boxGoodsList(Long shipmentId, Long secId, Integer isCover, Integer isRemove, Integer isDel) {
        BoxLoadDetailBackVO boxLoadDetailBackVO = new BoxLoadDetailBackVO();

        BoxCustomsDO boxCustomsDO = boxCustomsService.selectOne(new LambdaQueryWrapperX<BoxCustomsDO>()
                .eq(BoxCustomsDO::getShipmentId, shipmentId)
                .orderByDesc(BaseDO::getCreateTime)
                .last(" limit 1"));

        if (boxCustomsDO != null) {
            boxLoadDetailBackVO.setBoxCustomsBackVO(BoxCustomsConvert.INSTANCE.convert(boxCustomsDO));
        }


        //查询装柜的，要剔除已经移除的
        PreloadedReq query = new PreloadedReq();
        query.setLang(I18nMessage.getLang());
        query.setIsDel(isDel);
        query.setShipmentId(shipmentId);
        //设置为不能移除的
        query.setIsRemove(isRemove);
        query.setIsCover(isCover);
        List<BoxPreloadGoodsBackVO> goodsItemList = boxPreloadGoodsMapper.orderPreloaded(query);
        Map<Long, List<BoxPreloadGoodsBackVO>> sectionGoodsMap = goodsItemList.stream()
                .collect(Collectors.groupingBy(BoxPreloadGoodsBackVO::getSecId));

        List<BoxPreloadSectionDO> sectionList = getSectionListByShipmentId(shipmentId);


        //获取这个预装单的所有已装标签
        BoxLoadInfoQueryVO boxLoadInfoQueryVO = new BoxLoadInfoQueryVO();
        boxLoadInfoQueryVO.setShipmentId(shipmentId);
        List<BoxLoadInfoDO> loadInfoList = boxLoadInfoService.getBoxLoadInfoList(boxLoadInfoQueryVO);

        List<OrderItemDO> orderItemDOList = convertOrderItemList(goodsItemList);
        BoxGoodsStatistics boxGoodsStatistics = calculationStatistics(orderItemDOList);
        long unloadSize = loadInfoList.stream()
                .filter(t -> t.getIsUnload() == 1)
                .count();
        boxGoodsStatistics.setUnloadNum(unloadSize);
        boxGoodsStatistics.setLoadNum(loadInfoList.size());
        //统计合包箱数量
        calculateBoxMergeSum(shipmentId, boxGoodsStatistics);
        boxLoadDetailBackVO.setTotalStatistics(boxGoodsStatistics);

        if (secId != null && secId != 0L) {
            List<BoxPreloadGoodsBackVO> sectionGoodsList = sectionGoodsMap.get(secId);

            if (sectionGoodsList != null) {
                List<OrderItemDO> secOrderItemDOList = new ArrayList<>();
                for (BoxPreloadGoodsBackVO item : sectionGoodsList) {
                    OrderItemDO orderItemDO = new OrderItemDO();
                    BeanUtils.copyProperties(item, orderItemDO);
                    secOrderItemDOList.add(orderItemDO);
                }
                BoxGoodsStatistics secBoxGoodsStatistics = calculationStatistics(secOrderItemDOList);
                long secUnloadNum = loadInfoList.stream()
                        .filter(t -> t.getIsUnload() == 1)
                        .count();

                Set<Long> secOrderIdSet = secOrderItemDOList.stream()
                        .map(OrderItemDO::getOrderId)
                        .collect(Collectors.toSet());
                List<BoxLoadInfoDO> secLoadInfoList = loadInfoList.stream()
                        .filter(t -> secOrderIdSet.contains(t.getOrderId()))
                        .collect(Collectors.toList());
                secBoxGoodsStatistics.setUnloadNum(secUnloadNum);
                secBoxGoodsStatistics.setLoadNum(secLoadInfoList.size());
                //统计合包箱数量
                calculateBoxMergeSum(shipmentId, secBoxGoodsStatistics);
                boxLoadDetailBackVO.setSecStatistics(secBoxGoodsStatistics);
            }
        } else {
            boxLoadDetailBackVO.setSecStatistics(boxGoodsStatistics);
        }

        List<BoxLoadOrderVO> loadOrderList = new ArrayList<>();
        boxLoadDetailBackVO.setSectionOrderList(loadOrderList);

        //以部分分组
        for (BoxPreloadSectionDO sectionDO : sectionList) {
            //
            Long sectionId = sectionDO.getId();

            if (secId != null && secId != 0 && !sectionId.equals(secId)) {
                continue;
            }

            List<BoxPreloadGoodsBackVO> sectionGoodsList = sectionGoodsMap.get(sectionId);

            if (CollectionUtil.isEmpty(sectionGoodsList)) continue;

            //按照订单分组
            Map<Long, List<BoxPreloadGoodsBackVO>> orderItemsMap = sectionGoodsList.stream()
                    .collect(Collectors.groupingBy(BoxPreloadGoodsBackVO::getOrderId));

            //找出异常中的订单->未处理的
            List<OrderExceptionDO> exceptionList = orderExceptionService.list(new LambdaQueryWrapperX<OrderExceptionDO>()
                    .ne(OrderExceptionDO::getOrderExceptionStatus, 2)
            );
            Map<Long, List<OrderExceptionDO>> orderExceptionMap = exceptionList.stream()
                    .collect(Collectors.groupingBy(OrderExceptionDO::getOrderId));

            //按照订单分组
            Map<Long, List<BoxLoadInfoDO>> orderLoadsMap = loadInfoList.stream()
                    .collect(Collectors.groupingBy(BoxLoadInfoDO::getOrderId));

            for (Map.Entry<Long, List<BoxPreloadGoodsBackVO>> entry : orderItemsMap.entrySet()) {
                Long orderId = entry.getKey();
                List<BoxPreloadGoodsBackVO> goodsList = entry.getValue();

                BoxPreloadGoodsBackVO boxPreloadGoodsDO = goodsList.get(0);

                BoxLoadOrderVO orderVO = new BoxLoadOrderVO();

                BeanUtils.copyProperties(boxPreloadGoodsDO, orderVO);
                orderVO.setShipmentId(shipmentId);
                loadOrderList.add(orderVO);

                orderVO.setMultiSpecification(boxService.getMultiSpecification(goodsList));

                orderVO.setExceptionList(OrderExceptionConvert.INSTANCE.convertList(orderExceptionMap.get(orderId)));

                setSectionText(sectionId, sectionList, orderVO);

                orderVO.setGoodsList(goodsList);
                orderVO.setOrderId(orderId);

                orderVO.setAdjustToDestWarehouseId(boxPreloadGoodsDO.getAdjustToDestWarehouseId());
                orderVO.setWarehouseType(boxPreloadGoodsDO.getWarehouseType());

                orderVO.setOrderNo(boxPreloadGoodsDO.getOrderNo());
                orderVO.setUnit(boxPreloadGoodsDO.getUnit());
                orderVO.setCustomsType(boxPreloadGoodsDO.getCustomsType());
                orderVO.setDestWarehouseName(boxPreloadGoodsDO.getDestWarehouseName());
                orderVO.setTotalWorth(boxPreloadGoodsDO.getTotalWorth());
                orderVO.setIsExternalWarehouse(boxPreloadGoodsDO.getIsExternalWarehouse());
                orderVO.setTidanNum(boxPreloadGoodsDO.getTidanNum());
                orderVO.setPreloadId(boxPreloadGoodsDO.getId());

                List<OrderItemDO> orderStaticsList = new ArrayList<>();
                for (BoxPreloadGoodsBackVO item : goodsList) {
                    OrderItemDO orderItemDO = new OrderItemDO();
                    BeanUtils.copyProperties(item, orderItemDO);
                    orderStaticsList.add(orderItemDO);
                }
                BoxGoodsStatistics orderGoodsStatistics = calculationStatistics(orderStaticsList);
                //计划总箱数
                long numSum = orderGoodsStatistics.getNum();

                orderVO.setNum(numSum);

                //计划总体积
                BigDecimal volumeSum = orderGoodsStatistics.getVolume();
                orderVO.setVolume(volumeSum);

                //计划总重量
                BigDecimal weightSum = orderGoodsStatistics.getWeight();
                orderVO.setWeight(weightSum);

                orderVO.setChargeVolume(orderGoodsStatistics.getChargeVolume());
                orderVO.setChargeWeight(orderGoodsStatistics.getChargeWeight());

                //已装数量
                List<BoxLoadInfoDO> installList = orderLoadsMap.get(orderId);
                orderVO.setInstallNum(CollectionUtil.isNotEmpty(installList) ? installList.size() : 0);

                orderVO.setUnloadNum(0);
                if (installList != null) {
                    List<BoxLoadInfoDO> unloadList = installList.stream()
                            .filter(t -> t.getIsUnload() == 1)
                            .collect(Collectors.toList());
                    orderVO.setUnloadNum(unloadList.size());
                }
            }
            loadOrderList.sort((o1, o2) -> {
                if (o1.getTidanNum().compareTo(o2.getTidanNum()) == 0) {
                    return o1.getPreloadId().compareTo(o2.getPreloadId());
                }
                return o1.getTidanNum().compareTo(o2.getTidanNum());
            });
        }
        return boxLoadDetailBackVO;
    }


    @Override
    public BoxLoadDetailBackVO loadGoodsList(Long shipmentId, Long secId) {
        return boxGoodsList(shipmentId, secId, null, 0);
    }

    @Override
    public List<BoxLoadSectionBackVO> boxGoodsDetail(Long shipmentId) {
        List<BoxPreloadSectionDO> sectionList = getSectionListByShipmentId(shipmentId);
        List<BoxLoadSectionBackVO> dataList = new ArrayList<>();
        for (BoxPreloadSectionDO sectionDO : sectionList) {
            Long secId = sectionDO.getId();
            BoxLoadDetailBackVO secDetail = boxGoodsDetail(shipmentId, secId);
            dataList.add(createBoxSecDetail(secDetail, shipmentId, sectionDO));

        }
        return dataList;
    }

    private BoxLoadSectionBackVO createBoxSecDetail(BoxLoadDetailBackVO secDetail, Long shipmentId, BoxPreloadSectionDO sectionDO) {
        BoxLoadSectionBackVO boxLoadSectionBackVO = new BoxLoadSectionBackVO();
        boxLoadSectionBackVO.setSecStatistics(secDetail.getSecStatistics());
        boxLoadSectionBackVO.setSectionOrderList(secDetail.getSectionOrderList());
        boxLoadSectionBackVO.setShipmentId(shipmentId);
        boxLoadSectionBackVO.setId(sectionDO.getId());
        boxLoadSectionBackVO.setCreateTime(sectionDO.getCreateTime());
        return boxLoadSectionBackVO;
    }

    @Override
    public BoxLoadDetailBackVO boxGoodsDetail(Long shipmentId, Long secId) {
        BoxLoadDetailBackVO detailBackVO = boxGoodsList(shipmentId,
                secId, null, 0);

        //查询订单的报关费用
        List<BoxLoadOrderVO> orderVOList = detailBackVO.getSectionOrderList();
        if(CollectionUtil.isNotEmpty(orderVOList)) {
            List<Long> orderIdList = orderVOList.stream()
                    .map(BoxLoadOrderVO::getOrderId)
                    .collect(Collectors.toList());

            //找到这些订单的额外费用
            List<BoxCustomsExtraCostDO> extraCostDOList = boxCustomsExtraCostService.getBoxCustomsExtraCostByOrderIdList(orderIdList);
            Map<Long, BigDecimal> orderFeeMap = extraCostDOList.stream()
                .collect(Collectors.groupingBy(BoxCustomsExtraCostDO::getOrderId, CollectorsUtil.summingBigDecimal(BoxCustomsExtraCostDO::getFee)));

            List<BoxAbnormalDO> abnormalList = boxService.getAbnormalList(shipmentId);
            detailBackVO.setAbnormalList(BoxAbnormalConvert.INSTANCE.convertList(abnormalList));
            String dealOrderIds = null;
            BoxAbnormalDO boxAbnormalDO = null;
            if(CollectionUtil.isNotEmpty(abnormalList)) {
                boxAbnormalDO = abnormalList.get(0);
                dealOrderIds = boxAbnormalDO.getDealOrderIds();
            }
            if(StringUtils.isEmpty(dealOrderIds)) {
                dealOrderIds = "";
            }
            for (BoxLoadOrderVO orderVO : orderVOList) {
                orderVO.setCustomsFee(orderFeeMap.get(orderVO.getOrderId()));
                if(boxAbnormalDO == null) {
                    orderVO.setAbnormalDealStatus(1);
                } else {
                    boolean isDeal = dealOrderIds.contains(orderVO.getOrderId().toString());
                    orderVO.setAbnormalDealStatus(isDeal ? 1 : 0);
                }
            }
        }
        return detailBackVO;
    }

    @Override
    public Long selectByShipmentIdAndOrderNo(Long shipmentId, String orderNo) {
        //1.找出计划装箱的数量
        //设置为不能移除的
        List<BoxPreloadGoodsBackVO> goodsItemList = getShipGoodItemList(shipmentId);
        if (CollectionUtil.isEmpty(goodsItemList)) {
            throw exception(cn.iocoder.yudao.module.order.enums.ErrorCodeConstants.ORDER_NOT_EXISTS);
        }

        Set<Long> orderIdSet = goodsItemList.stream()
                .map(BoxPreloadGoodsBackVO::getOrderId)
                .collect(Collectors.toSet());
        List<OrderDO> orderDOList = orderQueryService.getOrderList(orderIdSet);
        orderDOList = orderDOList.stream()
                .filter(t -> t.getOrderNo().equals(orderNo))
                .collect(Collectors.toList());
        if (CollectionUtil.isEmpty(orderDOList)) {
            throw exception(cn.iocoder.yudao.module.order.enums.ErrorCodeConstants.ORDER_NOT_EXISTS);
        }
        return orderDOList.get(0).getOrderId();
    }

    @Override
    public BoxOrderPreloadStatistics orderPreloadPage(OrderPreloadReq query) {
        IPage<BoxOrderPreloadVo> mPage = MyBatisUtils.buildPage(query);
        query.setLang(I18nMessage.getLang());

        List<OrderPreloadVO> orderPreloadList = orderQueryService.orderPreloadList(query);

        if (CollectionUtil.isEmpty(orderPreloadList))
            return new BoxOrderPreloadStatistics();

        Long startWarehouseId = query.getStartWarehouseId();
        //校验始发仓
        if (startWarehouseId != null) {
            Iterator<OrderPreloadVO> it = orderPreloadList.iterator();
            while (it.hasNext()) {
                OrderPreloadVO preloadVO = it.next();
                Long adjustToDestWarehouseId = preloadVO.getAdjustToDestWarehouseId();
                if (adjustToDestWarehouseId != null && adjustToDestWarehouseId != 0) {
                    //有调仓，判断调仓是否符合条件,不符合条件则直接移除
                    if (!startWarehouseId.equals(adjustToDestWarehouseId)) it.remove();
                } else {
                    //没有调仓，判断始发仓是否符合条件
                    if (!startWarehouseId.equals(preloadVO.getStartWarehouseId())) it.remove();
                }
            }
        }

        //过滤掉调仓的情况，校验订单是否为空
        if (CollectionUtil.isEmpty(orderPreloadList)) return new BoxOrderPreloadStatistics();

        //过滤关联单有问题的订单
        filterRelationOrderStatus(orderPreloadList);
        if (CollectionUtil.isEmpty(orderPreloadList)) return new BoxOrderPreloadStatistics();

        List<BoxOrderPreloadVo> list = new ArrayList<>();
        for (OrderPreloadVO t : orderPreloadList) {
            BoxOrderPreloadVo vo = new BoxOrderPreloadVo();
            BeanUtils.copyProperties(t, vo);
            list.add(vo);
        }

        //符合条件的所有订单项
        List<Long> orderIdList = list.stream()
                .map(BoxOrderPreloadVo::getOrderId)
                .collect(Collectors.toList());


        List<OrderItemBackVO> orderItemList = orderItemService.getOrderItemBackByOrderId(orderIdList);

        //订单项过滤了入仓为0的数据，
        if (CollectionUtil.isEmpty(orderItemList)) return new BoxOrderPreloadStatistics();

        //订单对应的订单项列表
        Map<Long, List<OrderItemBackVO>> orderItemMap = orderItemList.stream()
                .collect(Collectors.groupingBy(OrderItemBackVO::getOrderId));

        //查找所有已预装的订单项
        List<Long> orderItemIdList = orderItemList.stream()
                .map(OrderItemBackVO::getOrderItemId)
                .collect(Collectors.toList());

        //已装商品
        List<BoxPreloadGoodsDO> boxPreloadGoodsDOList = boxPreloadGoodsMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .in(BoxPreloadGoodsDO::getOrderItemId, orderItemIdList)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        //订单项ID->已装商品
        Map<Long, BoxPreloadGoodsDO> itemIdMap = boxPreloadGoodsDOList.stream()
                .collect(Collectors.toMap(BoxPreloadGoodsDO::getOrderItemId, v -> v, (v1, v2) -> v2));

        //获取出货单ID列表
        List<Long> shipmentIdList = boxPreloadGoodsDOList.stream()
                .map(BoxPreloadGoodsDO::getShipmentId)
                .collect(Collectors.toList());

        Map<Long, BoxDO> boxMap = new HashMap<>();
        Map<Long, List<BoxPreloadSectionDO>> sectionMap = new HashMap<>();

        if (CollectionUtil.isNotEmpty(shipmentIdList)) {
            List<BoxDO> boxList = boxService.getBoxList(shipmentIdList);
            boxMap = boxList.stream()
                    .collect(Collectors.toMap(BoxDO::getId, v -> v));

            //找到出货单下面的所有部分，确定已装商品在第几部分
            List<BoxPreloadSectionDO> sectionDOList = boxPreloadSectionService.selectByShipmentIdList(shipmentIdList);
            sectionDOList.sort(Comparator.comparing(BoxPreloadSectionDO::getId));

            sectionMap = sectionDOList.stream()
                    .collect(Collectors.groupingBy(BoxPreloadSectionDO::getShipmentId));
        }


        //未预装的订单项列表
        List<OrderItemDO> unLoadItemList = new ArrayList<>();

        //如果订单的商品全部已装，则过滤掉这个订单
        Iterator<BoxOrderPreloadVo> it = list.iterator();
        while (it.hasNext()) {
            BoxOrderPreloadVo orderPreloadVO = it.next();
            //订单下的商品项,一定不为空，
            List<OrderItemBackVO> itemList = orderItemMap.get(orderPreloadVO.getOrderId());
            //过滤了为入仓的订单项，所以会有为null的情况,
            //没有订单项，删除这个订单，
            if (CollectionUtil.isEmpty(itemList)) {
                it.remove();
                continue;
            }

            List<BoxOrderItemBackVO> boxOrderItemBackVOList = new ArrayList<>();
            orderPreloadVO.setBoxOrderItemList(boxOrderItemBackVOList);

            //当所有的商品项都已经被预装了的话，则过滤掉这个订单
            List<String> loadInfoList = new ArrayList<>();
            for (OrderItemBackVO item : itemList) {
                BoxOrderItemBackVO boxOrderItemBackVO = new BoxOrderItemBackVO();
                BeanUtils.copyProperties(item, boxOrderItemBackVO);
                boxOrderItemBackVOList.add(boxOrderItemBackVO);

                Long orderItemId = item.getOrderItemId();
                BoxPreloadGoodsDO boxPreloadGoodsDO = itemIdMap.get(orderItemId);
                if (boxPreloadGoodsDO == null) {
                    //未预装
                    unLoadItemList.add(OrderItemConvert.INSTANCE.convert(item));
                } else {
                    //已预装
                    Long shipmentId = boxPreloadGoodsDO.getShipmentId();
                    BoxDO boxDO = boxMap.get(shipmentId);
                    if (boxDO == null) {
                        //出货单未找到?
                        unLoadItemList.add(OrderItemConvert.INSTANCE.convert(item));
                    } else {
                        Long secId = boxPreloadGoodsDO.getSecId();
                        List<BoxPreloadSectionDO> boxSectionList = sectionMap.get(shipmentId);
                        boxSectionList.sort(Comparator.comparing(BoxPreloadSectionDO::getId));
                        String secText = getSectionText(secId, boxSectionList);
                        String loadInfo = boxDO.getSelfNo() + secText;
                        boxOrderItemBackVO.setOperateText(loadInfo);
                        loadInfoList.add(loadInfo);
                    }
                }
            }
            if (boxOrderItemBackVOList.size() == loadInfoList.size()) {
                //这个订单都已经被预装了
                it.remove();
            }
        }

        List<Long> resultOrderIdList = list.stream()
                .map(OrderPreloadVO::getOrderId)
                .collect(Collectors.toList());
        Integer orderStatus = query.getOrderStatus();
        if (orderStatus != null && CollectionUtil.isNotEmpty(resultOrderIdList)) {
            List<Long> matchIdList = new ArrayList<>();
            if (orderStatus == 1) {  //拆单
                //过滤掉不是拆单的订单
                List<OrderDO> orderDOList = orderQueryService.getOrderList(resultOrderIdList);
                matchIdList = orderDOList.stream()
                        .filter(t -> (t.getParentOrderId() != null && t.getParentOrderId() != 0L))
                        .map(OrderDO::getOrderId)
                        .collect(Collectors.toList());
            } else if (orderStatus == 2) {  //关联单
                //找出所有的关联单
                List<OrderGuanlianDO> guanlianList = orderGuanlianService.getGuanlianList(resultOrderIdList);
                matchIdList = guanlianList.stream()
                        .map(OrderGuanlianDO::getOrderId)
                        .collect(Collectors.toList());
                matchIdList.addAll(guanlianList.stream()
                        .map(OrderGuanlianDO::getRelateOrderId)
                        .collect(Collectors.toList())
                );
            }
            List<Long> finalMatchIdList = matchIdList;
            list = list.stream()
                    .filter(t -> finalMatchIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
            unLoadItemList = unLoadItemList.stream()
                    .filter(t -> finalMatchIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
        }
        if (CollectionUtil.isNotEmpty(unLoadItemList)) {
            //过滤审核中的订单
            Set<Long> oIdList = unLoadItemList.stream()
                    .map(OrderItemDO::getOrderId)
                    .collect(Collectors.toSet());
            List<OrderApprovalDO> orderApprovalList = boxService.getOrderApprovalIng(oIdList);
            List<Long> approvalIdList = orderApprovalList.stream()
                    .map(OrderApprovalDO::getOrderId)
                    .collect(Collectors.toList());
            list = list.stream()
                    .filter(t -> !approvalIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
            unLoadItemList = unLoadItemList.stream()
                    .filter(t -> !approvalIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
        }


        //统计待预装箱数、重量、体积
        BoxGoodsStatistics boxGoodsStatistics = calculationStatistics(unLoadItemList);


        //按照最早入仓时间排序
        list.sort(new Comparator<BoxOrderPreloadVo>() {
            @Override
            public int compare(BoxOrderPreloadVo o1, BoxOrderPreloadVo o2) {
                if (o1.getRucangTime() != null && o2.getRucangTime() != null) {
                    return o1.getRucangTime().compareTo(o2.getRucangTime());
                } else {
                    o1.setRucangTime(new Date());
                    o2.setRucangTime(new Date());
                    return o1.getRucangTime().compareTo(o2.getRucangTime());
                }
            }
        });

        //内存分页
        //当前页码
        long page = mPage.getCurrent();
        //每页条数
        long limit = mPage.getSize();
        //忽略上一页，如果是第一页肯定不用忽略
        long skipNum = limit * (page - 1);

        float count = list.size();
        //计算最大页数
        float number = count / limit;
        int pages = (int) Math.ceil(number);
        mPage.setPages(pages);

        List<BoxOrderPreloadVo> records = list.stream()
                .skip(skipNum)
                .limit(limit)
                .collect(Collectors.toList());
        mPage.setTotal(list.size());
        mPage.setRecords(records);

        List<ProductAttrDO> productAttrDOList = productAttrService.getProductAttrList();
        Map<String, String> idNameMap = productAttrDOList.stream()
                .collect(Collectors.toMap(attr -> String.valueOf(attr.getId()), ProductAttrDO::getAttrName));


        //找出这些订单的关联单
        for (BoxOrderPreloadVo boxOrderPreloadVo : records) {
            Long orderId = boxOrderPreloadVo.getOrderId();
            List<OrderDO> relateOrderList = orderGuanlianService.getRelateOrderListByOrderId(orderId);
            boxOrderPreloadVo.setRelateOrderList(OrderConvert.INSTANCE.convertMiniList(relateOrderList));

            List<BoxOrderItemBackVO> boxOrderItemList = boxOrderPreloadVo.getBoxOrderItemList();
            for (BoxOrderItemBackVO orderItemBackVO : boxOrderItemList) {
                orderItemBackVO.setAttrNameList(getAttrNameByIds(orderItemBackVO.getProdAttrIds(), idNameMap));

                orderItemBackVO.setWarehouseInAttrNameList(
                        getAttrNameByIds(orderItemBackVO.getWarehouseInProdAttrIds(), idNameMap)
                );
            }
        }

        BoxOrderPreloadStatistics boxOrderPreloadStatistics = new BoxOrderPreloadStatistics();
        boxOrderPreloadStatistics.setDataList(PageResult.of(mPage));
        boxOrderPreloadStatistics.setUnloadStatistics(boxGoodsStatistics);
        return boxOrderPreloadStatistics;
    }

    private OrderConsigneeDO getFilterOrderConsigneeDO(BoxDO boxDO, List<BoxPreloadGoodsDO> loadList) {
        Integer destinationClearance = boxDO.getDestinationClearance();
        Integer deliveryType = boxDO.getDeliveryType();

        //客户+单票，只能放入一个客户订单
        boolean isLimit = destinationClearance != null && deliveryType != null
                && destinationClearance == 3 && deliveryType == 2;

        //找到这个出货已经预装的订单
        Set<Long> orderIdSets = loadList.stream()
                .map(BoxPreloadGoodsDO::getOrderId)
                .collect(Collectors.toSet());

        OrderConsigneeDO filterConsigneeDO = null;

        //已经有预装订单，并且需要限制只能放入一个客户订单
        if (CollectionUtil.isNotEmpty(orderIdSets) && isLimit) {
            Long existOrderId = new ArrayList<>(orderIdSets).get(0);
            OrderDO existDO = boxService.getOrder(existOrderId);
            filterConsigneeDO = boxService.getOrderConsignee(existDO);
        }
        return filterConsigneeDO;
    }

    @Override
    public PreloadResultVO createBoxPreloadGoodsAir(BoxPreloadGoodsCreateReqVO createReqVO) {
        Long shipmentId = createReqVO.getShipmentId();

        //找到出货单
        BoxDO boxDO = boxService.getBox(shipmentId);
        if (boxDO == null) {
            throw exception(BOX_NOT_EXISTS);
        }

        boxService.checkApproval(shipmentId, null);
        Long orderId = createReqVO.getOrderId();
        Long secId = createReqVO.getSecId();

        if (createReqVO.getIsCover() == 0) {
            //排单，先校验出货是否已经预装审核通过了
            Integer prStatus = boxDO.getPrStatus();
            if (prStatus == StStatusEnum.SORTING_APPROVAL_SUCCESS.getStStatus()) {
                throw new ServiceException(500, "出货已分拣审核通过。");
            }
        } else {
            Integer airShipmentStatus = boxDO.getAirShipmentStatus();
            if (airShipmentStatus == AirShipmentStatusEnum.SHIPMENT.getStatus()) {
                throw new ServiceException(500, "已出货不能补单。");
            }
        }

        //找到这个出货单已预装的商品
        List<BoxPreloadGoodsDO> loadList = baseMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );

        OrderConsigneeDO filterConsigneeDO = getFilterOrderConsigneeDO(boxDO, loadList);

        OrderDO orderDO = orderService.getById(orderId);
        if(filterConsigneeDO != null) {
            //校验收货人是否是同一个人
            OrderConsigneeDO consigneeDO = boxService.getOrderConsignee(orderDO);

            //校验是否是用一个人 ,通过手机号

            if(consigneeDO != null && !consigneeDO.getPhone().equals(filterConsigneeDO.getPhone())) {
                throw new ServiceException(500, "当前自编号是客户+自清，收货人必须是手机号相同才可以进行分拣");
            }
        }

        //如果都符合，下面展示互斥和关联订单的弹窗
        Integer relationStatus = createReqVO.getRelationStatus();
        //校验是否是互斥订单
        if(relationStatus == null || relationStatus == 2) {
            //校验互斥订单
            checkMutualOrder(loadList, orderDO);
        }

        List<OrderGuanlianDO> orderRelationList = orderGuanlianService.getRelationList(orderId);
        List<OrderDO> orderList;
        StringBuilder sb = new StringBuilder();

        boolean hasRelationOrder = CollectionUtil.isNotEmpty(orderRelationList);

        if(hasRelationOrder) {
            Set<Long> orderIdSet = orderRelationList.stream()
                    .flatMap(o -> Stream.of(o.getOrderId(), o.getRelateOrderId()))
                    .collect(Collectors.toSet());
            //所有需要预装的订单
            orderList = orderService.listByIds(orderIdSet);

            OrderTree orderTree = orderGuanlianService.getAllRelateOrderList(orderDO.getOrderNo(), orderRelationList);
            //2.有关联订单，首先列出来关联关系
            String relateMsg = orderTree.toString();
            sb.append(relateMsg);
        } else {
            orderList = Collections.singletonList(orderDO);
        }

        List<Integer> normalStatusList = Collections.singletonList(4);
        //不符合条件的订单
        List<OrderDO> notMatchStatusList = orderList.stream()
                .filter(t -> !normalStatusList.contains(t.getAirShipment()))
                .collect(Collectors.toList());

        List<OrderDO> abnormalList = orderList.stream()
                .filter(t -> t.getAbnormalState() != 0)
                .collect(Collectors.toList());

        List<OrderDO> auditList = orderList.stream()
                .filter(t -> t.getAuditType() != 0)
                .collect(Collectors.toList());

        boolean isSuit = true;
        if (CollectionUtil.isNotEmpty(notMatchStatusList)) {
            isSuit = false;
            if (hasRelationOrder) {
                sb.append("<br>");
            }
            List<String> orderNoList = notMatchStatusList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            String orderNos = Joiner.on(",").join(orderNoList);
            sb.append("订单:").append(orderNos).append("未完成备货，不能排单");
        }

        if (CollectionUtil.isNotEmpty(abnormalList)) {
            isSuit = false;
            if (hasRelationOrder) {
                sb.append("<br>");
            }
            List<String> orderNoList = abnormalList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            String orderNos = Joiner.on(",").join(orderNoList);
            sb.append("订单:").append(orderNos).append("存在异常");
        }

        if (CollectionUtil.isNotEmpty(auditList)) {
            isSuit = false;
            if (hasRelationOrder) {
                sb.append("<br>");
            }
            List<String> orderNoList = auditList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            String orderNos = Joiner.on(",").join(orderNoList);
            sb.append("订单:").append(orderNos).append("审核中");
        }

        if (!isSuit) {
            throw new ServiceException(500, sb.toString());
        }

        List<Long> orderIdList = orderList.stream()
                .map(OrderDO::getOrderId)
                .collect(Collectors.toList());

        //过滤了入仓为0的数据
        List<OrderItemBackVO> orderItemList = orderItemService.getOrderItemBackByOrderId(orderIdList);
        if(CollectionUtil.isEmpty(orderItemList)) {
            throw new ServiceException(500, "订单项不存在");
        }

        Set<Long> loadIdList = loadList.stream()
                .map(BoxPreloadGoodsDO::getOrderItemId)
                .collect(Collectors.toSet());

        //过滤掉已经预装的
        orderItemList = orderItemList.stream()
                .filter(t -> !loadIdList.contains(t.getOrderItemId()))
                .collect(Collectors.toList());

        List<Long> orderItemIdList = orderItemList.stream()
                .map(OrderItemBackVO::getOrderItemId)
                .collect(Collectors.toList());

        //1.校验订单项是否已预装
        checkInstallItem(loadList, orderItemIdList, orderList);

        //2.校验是否都预装都同一个部分
        checkInstallSection(secId, loadList, orderItemIdList);

        //3.检查仓库
        for (OrderDO item : orderList) {
            try {
                checkWarehouse(boxDO, item);
            } catch (Exception e) {
                isSuit = false;
                sb.append("订单:").append(item.getOrderNo()).append(",").append(e.getMessage()).append("<br>");
            }
        }
        if (!isSuit) {
            throw new ServiceException(500, sb.toString());
        }

        //都符合，预装，看是否弹出提示
        if (relationStatus == null || relationStatus == 1) {
            if (hasRelationOrder) {
                throw new ServiceException(566, sb.toString());
            }

        }

        List<BoxPreloadGoodsDO> preloadGoodsDOList = new ArrayList<>();
        for (OrderItemBackVO orderItem : orderItemList) {
            BoxPreloadGoodsDO boxPreloadGoods = BoxPreloadGoodsConvert.INSTANCE.convert(createReqVO);
            boxPreloadGoods.setOrderItemId(orderItem.getOrderItemId());
            boxPreloadGoods.setOrderId(orderItem.getOrderId());
            if (createReqVO.getIsCover() != null) {
                boxPreloadGoods.setIsCover(createReqVO.getIsCover());
            }
            preloadGoodsDOList.add(boxPreloadGoods);
        }

        // 插入
        boxPreloadGoodsMapper.insertBatch(preloadGoodsDOList);

        if (boxDO.getPrStatus() == StStatusEnum.NO_SORTING.getStStatus()) {
            //修改为分拣中
            boxDO.setPrStatus(StStatusEnum.SORTING.getStStatus());
            boxService.updateById(boxDO);
            for (Long oId : orderIdList) {
                boxService.updateOrderStatus(oId, null, null,
                        BoxStatusEnum.PREINSTALLING.getStatus(), null, null, Boolean.FALSE);
            }
            boxService.addOrderLog(orderIdList, OrderShipmentLog.SORTING_ADD, "");
        } else if (boxDO.getPrStatus() == StStatusEnum.SORTING_APPROVAL_SUCCESS.getStStatus()) {
            //补单。修改订单状态
            for (Long oId : orderIdList) {
                boxService.updateOrderStatus(oId, OrderStatusEnum.PRE_INSTALLED.getValue(), 0,
                        BoxStatusEnum.PREINSTALL_EXAMINE_SUCCESS.getStatus(), null, null, Boolean.FALSE);
            }

            //合包补单  如果为已合包修改为待合包
            if (boxDO.getMergePkgStatus() == MergePkgStatusEnum.MERGED.getStatus()) {
                boxDO.setMergePkgStatus(MergePkgStatusEnum.UNMERGE.getStatus());
                boxService.updateById(boxDO);
            }

            //生成提单号
            boxService.generateBillLadingNo(shipmentId, true, false);

            boxService.addOrderLog(orderIdList, OrderShipmentLog.MERGE_PATCH, "");
        } else {
            for (Long oId : orderIdList) {
                boxService.updateOrderStatus(oId, null, null,
                        BoxStatusEnum.PREINSTALLING.getStatus(), null, null, Boolean.FALSE);
            }
            boxService.addOrderLog(orderIdList, OrderShipmentLog.SORTING_ADD, "");
        }

        //把自编号写入订单表
        for (Long oId : orderIdList) {
            boxService.updateOrderSelfNo(oId, boxDO.getSelfNo());
        }

        return new PreloadResultVO();
    }

    @Override
    public BoxOrderPreloadStatistics orderPreloadPageAir(OrderPreloadReq query) {
        IPage<BoxOrderPreloadVo> mPage = MyBatisUtils.buildPage(query);
        query.setLang(I18nMessage.getLang());

        Long airShipmentId = query.getShipmentId();
        if (airShipmentId == null) {
            throw new ServiceException(500, "shipmentId不能为空");
        }
        BoxDO airBox = boxService.getBox(airShipmentId);


        //找到这个出货单已预装的商品
        List<BoxPreloadGoodsDO> loadList = baseMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getShipmentId, airShipmentId)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );

        OrderConsigneeDO filterConsigneeDO = getFilterOrderConsigneeDO(airBox, loadList);
        if (filterConsigneeDO != null) {
            filterConsigneeDO.setRelationId(filterConsigneeDO.getRelationId());
        }

        List<OrderPreloadVO> orderPreloadList = orderQueryService.orderPreloadListAir(query);

        if (CollectionUtil.isEmpty(orderPreloadList)) return new BoxOrderPreloadStatistics();

        Long startWarehouseId = query.getStartWarehouseId();
        //校验始发仓
        if (startWarehouseId != null) {
            Iterator<OrderPreloadVO> it = orderPreloadList.iterator();
            while (it.hasNext()) {
                OrderPreloadVO preloadVO = it.next();
                Long adjustToDestWarehouseId = preloadVO.getAdjustToDestWarehouseId();
                if (adjustToDestWarehouseId != null && adjustToDestWarehouseId != 0) {
                    //有调仓，判断调仓是否符合条件,不符合条件则直接移除
                    if (!startWarehouseId.equals(adjustToDestWarehouseId)) it.remove();
                } else {
                    //没有调仓，判断始发仓是否符合条件
                    if (!startWarehouseId.equals(preloadVO.getStartWarehouseId())) it.remove();
                }
            }
        }

        //过滤掉调仓的情况，校验订单是否为空
        if (CollectionUtil.isEmpty(orderPreloadList)) return new BoxOrderPreloadStatistics();

        //过滤关联单有问题的订单
        filterRelationOrderStatus(orderPreloadList);
        if (CollectionUtil.isEmpty(orderPreloadList)) return new BoxOrderPreloadStatistics();

        List<BoxOrderPreloadVo> list = new ArrayList<>();
        for (OrderPreloadVO t : orderPreloadList) {
            BoxOrderPreloadVo vo = new BoxOrderPreloadVo();
            BeanUtils.copyProperties(t, vo);
            list.add(vo);
        }

        //符合条件的所有订单项
        List<Long> orderIdList = list.stream()
                .map(BoxOrderPreloadVo::getOrderId)
                .collect(Collectors.toList());


        List<OrderItemBackVO> orderItemList = orderItemService.getOrderItemBackByOrderId(orderIdList);

        //订单项过滤了入仓为0的数据，
        if (CollectionUtil.isEmpty(orderItemList)) return new BoxOrderPreloadStatistics();

        //过滤入仓特性条件
        if (StringUtils.isNotBlank(query.getAttrId())) {
            orderItemList = orderItemList.stream()
                    .filter(t -> StringUtils.isNotBlank(t.getWarehouseInProdAttrIds()))
                    .filter(t -> t.getWarehouseInProdAttrIds().contains(query.getAttrId()))
                    .collect(Collectors.toList());
        }

        if (CollectionUtil.isEmpty(orderItemList)) return new BoxOrderPreloadStatistics();

        //订单对应的订单项列表
        Map<Long, List<OrderItemBackVO>> orderItemMap = orderItemList.stream()
                .collect(Collectors.groupingBy(OrderItemBackVO::getOrderId));

        //查找所有已预装的订单项
        List<Long> orderItemIdList = orderItemList.stream()
                .map(OrderItemBackVO::getOrderItemId)
                .collect(Collectors.toList());

        //已装商品
        List<BoxPreloadGoodsDO> boxPreloadGoodsDOList = boxPreloadGoodsMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .in(BoxPreloadGoodsDO::getOrderItemId, orderItemIdList)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        //订单项ID->已装商品
        Map<Long, BoxPreloadGoodsDO> itemIdMap = boxPreloadGoodsDOList.stream()
                .collect(Collectors.toMap(BoxPreloadGoodsDO::getOrderItemId, v -> v, (v1, v2) -> v2));

        //获取出货单ID列表
        List<Long> shipmentIdList = boxPreloadGoodsDOList.stream()
                .map(BoxPreloadGoodsDO::getShipmentId)
                .collect(Collectors.toList());

        Map<Long, BoxDO> boxMap = new HashMap<>();
        Map<Long, List<BoxPreloadSectionDO>> sectionMap = new HashMap<>();

        if (CollectionUtil.isNotEmpty(shipmentIdList)) {
            List<BoxDO> boxList = boxService.getBoxList(shipmentIdList);
            boxMap = boxList.stream()
                    .collect(Collectors.toMap(BoxDO::getId, v -> v));

            //找到出货单下面的所有部分，确定已装商品在第几部分
            List<BoxPreloadSectionDO> sectionDOList = boxPreloadSectionService.selectByShipmentIdList(shipmentIdList);
            sectionDOList.sort(Comparator.comparing(BoxPreloadSectionDO::getId));

            sectionMap = sectionDOList.stream()
                    .collect(Collectors.groupingBy(BoxPreloadSectionDO::getShipmentId));
        }


        //未预装的订单项列表
        List<OrderItemDO> unLoadItemList = new ArrayList<>();

        //如果订单的商品全部已装，则过滤掉这个订单
        Iterator<BoxOrderPreloadVo> it = list.iterator();
        while (it.hasNext()) {
            BoxOrderPreloadVo orderPreloadVO = it.next();
            //订单下的商品项,一定不为空，
            List<OrderItemBackVO> itemList = orderItemMap.get(orderPreloadVO.getOrderId());
            //过滤了为入仓的订单项，所以会有为null的情况,
            //没有订单项，删除这个订单，
            if (CollectionUtil.isEmpty(itemList)) {
                it.remove();
                continue;
            }

            List<BoxOrderItemBackVO> boxOrderItemBackVOList = new ArrayList<>();
            orderPreloadVO.setBoxOrderItemList(boxOrderItemBackVOList);

            //当所有的商品项都已经被预装了的话，则过滤掉这个订单
            List<String> loadInfoList = new ArrayList<>();
            for (OrderItemBackVO item : itemList) {
                BoxOrderItemBackVO boxOrderItemBackVO = new BoxOrderItemBackVO();
                BeanUtils.copyProperties(item, boxOrderItemBackVO);
                boxOrderItemBackVOList.add(boxOrderItemBackVO);

                Long orderItemId = item.getOrderItemId();
                BoxPreloadGoodsDO boxPreloadGoodsDO = itemIdMap.get(orderItemId);
                if (boxPreloadGoodsDO == null) {
                    //未预装
                    unLoadItemList.add(OrderItemConvert.INSTANCE.convert(item));
                } else {
                    //已预装
                    Long shipmentId = boxPreloadGoodsDO.getShipmentId();
                    BoxDO boxDO = boxMap.get(shipmentId);
                    if (boxDO == null) {
                        //出货单未找到?
                        unLoadItemList.add(OrderItemConvert.INSTANCE.convert(item));
                    } else {
                        Long secId = boxPreloadGoodsDO.getSecId();
                        List<BoxPreloadSectionDO> boxSectionList = sectionMap.get(shipmentId);
                        boxSectionList.sort(Comparator.comparing(BoxPreloadSectionDO::getId));
                        String secText = getSectionText(secId, boxSectionList);
                        String loadInfo = boxDO.getSelfNo() + secText;
                        boxOrderItemBackVO.setOperateText(loadInfo);
                        loadInfoList.add(loadInfo);
                    }
                }
            }
            if (boxOrderItemBackVOList.size() == loadInfoList.size()) {
                //这个订单都已经被预装了
                it.remove();
            }
        }

        List<Long> resultOrderIdList = list.stream()
                .map(OrderPreloadVO::getOrderId)
                .collect(Collectors.toList());
        Integer orderStatus = query.getOrderStatus();
        if (orderStatus != null && CollectionUtil.isNotEmpty(resultOrderIdList)) {
            List<Long> matchIdList = new ArrayList<>();
            if (orderStatus == 1) {  //拆单
                //过滤掉不是拆单的订单
                List<OrderDO> orderDOList = orderQueryService.getOrderList(resultOrderIdList);
                matchIdList = orderDOList.stream()
                        .filter(t -> (t.getParentOrderId() != null && t.getParentOrderId() != 0L))
                        .map(OrderDO::getOrderId)
                        .collect(Collectors.toList());
            } else if (orderStatus == 2) {  //关联单
                //找出所有的关联单
                List<OrderGuanlianDO> guanlianList = orderGuanlianService.getGuanlianList(resultOrderIdList);
                matchIdList = guanlianList.stream()
                        .map(OrderGuanlianDO::getOrderId)
                        .collect(Collectors.toList());
                matchIdList.addAll(guanlianList.stream()
                        .map(OrderGuanlianDO::getRelateOrderId)
                        .collect(Collectors.toList())
                );
            }
            List<Long> finalMatchIdList = matchIdList;
            list = list.stream()
                    .filter(t -> finalMatchIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
            unLoadItemList = unLoadItemList.stream()
                    .filter(t -> finalMatchIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
        }
        if (CollectionUtil.isNotEmpty(unLoadItemList)) {
            //过滤审核中的订单
            Set<Long> oIdList = unLoadItemList.stream()
                    .map(OrderItemDO::getOrderId)
                    .collect(Collectors.toSet());
            List<OrderApprovalDO> orderApprovalList = boxService.getOrderApprovalIng(oIdList);
            List<Long> approvalIdList = orderApprovalList.stream()
                    .map(OrderApprovalDO::getOrderId)
                    .collect(Collectors.toList());
            list = list.stream()
                    .filter(t -> !approvalIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
            unLoadItemList = unLoadItemList.stream()
                    .filter(t -> !approvalIdList.contains(t.getOrderId()))
                    .collect(Collectors.toList());
        }


        //统计待预装箱数、重量、体积
        BoxGoodsStatistics boxGoodsStatistics = calculationStatistics(unLoadItemList);

        //内存分页
        //当前页码
        long page = mPage.getCurrent();
        //每页条数
        long limit = mPage.getSize();
        //忽略上一页，如果是第一页肯定不用忽略
        long skipNum = limit * (page - 1);

        float count = list.size();
        //计算最大页数
        float number = count / limit;
        int pages = (int) Math.ceil(number);
        mPage.setPages(pages);

        List<BoxOrderPreloadVo> records = list.stream()
                .skip(skipNum)
                .limit(limit)
                .collect(Collectors.toList());
        mPage.setTotal(list.size());
        mPage.setRecords(records);

        List<ProductAttrDO> productAttrDOList = productAttrService.getProductAttrList();
        Map<String, String> idNameMap = productAttrDOList.stream()
                .collect(Collectors.toMap(attr -> String.valueOf(attr.getId()), ProductAttrDO::getAttrName));


        Set<Long> lineIdList = records.stream()
                .map(OrderPreloadVO::getChannelId)
                .collect(Collectors.toSet());
        Map<Long, ChannelDO> channelDOMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(lineIdList)) {
            List<ChannelDO> channelDOList = channelService.getChannelList(lineIdList);
            channelDOMap = channelDOList.stream()
                    .collect(Collectors.toMap(ChannelDO::getChannelId, v -> v));
        }

        //找出这些订单的关联单
        for (BoxOrderPreloadVo boxOrderPreloadVo : records) {
            Long orderId = boxOrderPreloadVo.getOrderId();
            List<OrderDO> relateOrderList = orderGuanlianService.getRelateOrderListByOrderId(orderId);
            boxOrderPreloadVo.setRelateOrderList(OrderConvert.INSTANCE.convertMiniList(relateOrderList));

            Long channelId = boxOrderPreloadVo.getChannelId();
            ChannelDO channelDO = channelDOMap.get(channelId);
            if (channelDO != null) {
                boxOrderPreloadVo.setAttrNameList(getAttrNameByIds(channelDO.getAttrId(), idNameMap));
            }

            List<BoxOrderItemBackVO> boxOrderItemList = boxOrderPreloadVo.getBoxOrderItemList();
            for (BoxOrderItemBackVO orderItemBackVO : boxOrderItemList) {
                orderItemBackVO.setAttrNameList(getAttrNameByIds(orderItemBackVO.getProdAttrIds(), idNameMap));

                orderItemBackVO.setWarehouseInAttrNameList(
                        getAttrNameByIds(orderItemBackVO.getWarehouseInProdAttrIds(), idNameMap)
                );
            }
        }

        BoxOrderPreloadStatistics boxOrderPreloadStatistics = new BoxOrderPreloadStatistics();
        boxOrderPreloadStatistics.setDataList(PageResult.of(mPage));
        boxOrderPreloadStatistics.setUnloadStatistics(boxGoodsStatistics);
        return boxOrderPreloadStatistics;
    }

    private List<String> getAttrNameByIds(String attrIds, Map<String, String> idNameMap) {
        if (StringUtils.isNotBlank(attrIds)) {
            String[] attrIdArray = attrIds.split(",");
            List<String> nameList = new ArrayList<>();
            for (String attrId : attrIdArray) {
                //map一定包含数据，否则是数据错误
                nameList.add(idNameMap.get(attrId));
            }
            return nameList;
        }
        return null;
    }

    private void filterRelationOrderStatus(List<OrderPreloadVO> orderPreloadList) {
        Iterator<OrderPreloadVO> it = orderPreloadList.iterator();
        while (it.hasNext()) {
            OrderPreloadVO orderPreloadVO = it.next();
            String guanlianOrderStatus = orderPreloadVO.getGuanLianOrderStatus();
            if (StringUtils.isEmpty(guanlianOrderStatus)) continue;
            JSONArray jsonArray = JSONArray.parseArray(guanlianOrderStatus);
            if (jsonArray.size() > 0) {
                //表示该订单的关联单-有异常或者在审核中或者未入仓
                it.remove();
            }
        }
    }

    private String getSectionText(Long secId, List<BoxPreloadSectionDO> boxSectionList) {
        Integer lang = I18nMessage.getLang();

        StringBuilder sb = new StringBuilder();
        if (Objects.equals(lang, LangEnum.ZH.getLang())) {
            sb.append("第");
        } else {
            sb.append("section ");
        }
        for (int i = 1; i <= boxSectionList.size(); i++) {
            BoxPreloadSectionDO item = boxSectionList.get(i - 1);
            if (item.getId().equals(secId)) {
                sb.append(i);
                break;
            }
        }
        if (Objects.equals(lang, LangEnum.ZH.getLang())) {
            sb.append("部分");
        }
        return sb.toString();
    }

    private void setSectionText(Long secId, List<BoxPreloadSectionDO> boxSectionList, BoxLoadOrderVO orderVO) {
        Integer lang = I18nMessage.getLang();

        StringBuilder sb = new StringBuilder();
        int sectionIndex = 1;
        if (Objects.equals(lang, LangEnum.ZH.getLang())) {
            sb.append("第");
        } else {
            sb.append("section ");
        }
        for (int i = 1; i <= boxSectionList.size(); i++) {
            BoxPreloadSectionDO item = boxSectionList.get(i - 1);
            if (item.getId().equals(secId)) {
                sb.append(i);
                sectionIndex = i;
                break;
            }
        }
        if (Objects.equals(lang, LangEnum.ZH.getLang())) {
            sb.append("部分");
        }
        orderVO.setSectionName(sb.toString());
        orderVO.setSectionIndex(sectionIndex);
    }

    @Override
    public Map<Long, BoxGoodsStatistics> boxStatistics(List<Long> shipmentIdList) {
        PreloadedReq query = new PreloadedReq();
        query.setLang(I18nMessage.getLang());
        query.setShipmentIdList(shipmentIdList);
        //设置为不能移除的
        query.setIsRemove(0);
        //获取所有预装的商品
        List<BoxPreloadGoodsBackVO> goodsItemList = boxPreloadGoodsMapper.orderPreloaded(query);

        //找到所有订单
        Set<Long> orderIdSet = goodsItemList.stream()
                .map(BoxPreloadGoodsBackVO::getOrderId)
                .collect(Collectors.toSet());

        //shipment
        Map<Long, Set<Long>> shipmentOrderMap = new HashMap<>();
        for (BoxPreloadGoodsBackVO item : goodsItemList) {
            Long shipmentId = item.getShipmentId();
            shipmentOrderMap.computeIfAbsent(shipmentId, k -> new HashSet<>()).add(item.getOrderId());
        }

        List<OrderDO> orderDOList = orderQueryService.getOrderList(orderIdSet);

        BoxLoadInfoQueryVO boxLoadInfoQueryVO = new BoxLoadInfoQueryVO();
        boxLoadInfoQueryVO.setShipmentIdList(shipmentIdList);
        List<BoxLoadInfoDO> loadInfoList = boxLoadInfoService.getBoxLoadInfoList(boxLoadInfoQueryVO);

        Map<Long, List<BoxLoadInfoDO>> shipmentLoadMap = loadInfoList.stream()
                .collect(Collectors.groupingBy(BoxLoadInfoDO::getShipmentId));

        Map<Long, BoxGoodsStatistics> shipmentStaticsMap = new HashMap<>();
        for (Long shipmentId : shipmentIdList) {
            List<BoxLoadInfoDO> loadList = shipmentLoadMap.get(shipmentId);
            if (loadList == null) loadList = new ArrayList<>();

            Set<Long> itemOrderIdSet = shipmentOrderMap.get(shipmentId);
            List<OrderDO> itemOrderList = null;
            if (itemOrderIdSet != null) {
                itemOrderList = orderDOList.stream()
                        .filter(t -> itemOrderIdSet.contains(t.getOrderId()))
                        .collect(Collectors.toList());
            }
            BoxGoodsStatistics boxGoodsStatistics = calculateByOrderList(loadList, itemOrderList);
            shipmentStaticsMap.put(shipmentId, boxGoodsStatistics);
        }
        return shipmentStaticsMap;
    }

    private List<OrderItemDO> convertOrderItemList(List<BoxPreloadGoodsBackVO> goodsItemList) {
        List<OrderItemDO> orderItemDOList = new ArrayList<>();
        for (BoxPreloadGoodsBackVO item : goodsItemList) {
            OrderItemDO orderItemDO = new OrderItemDO();
            BeanUtils.copyProperties(item, orderItemDO);
            orderItemDOList.add(orderItemDO);
        }
        return orderItemDOList;
    }


    private BoxGoodsStatistics calculateByOrderList(List<BoxLoadInfoDO> loadInfoList, Collection<OrderDO> orderList) {
        //计划统计
        BoxGoodsStatistics boxStatistics = calculationStatisticsByOrderList(orderList);
        //装柜统计
        //获取这个预装单的所有已装标签
        boxStatistics.setLoadNum(loadInfoList.size());

        //卸柜统计
        List<BoxLoadInfoDO> unloadList = loadInfoList.stream()
                .filter(t -> t.getIsUnload() == 1)
                .collect(Collectors.toList());
        boxStatistics.setUnloadNum(unloadList.size());

        long planNum = boxStatistics.getNum();
        if (planNum != 0) {
            //平均计算
            BigDecimal planVolume = boxStatistics.getVolume();
            BigDecimal planWeight = boxStatistics.getWeight();

            long loadNum = boxStatistics.getLoadNum();
            long unloadNum = boxStatistics.getUnloadNum();

            BigDecimal loadVolume;
            BigDecimal loadWeight;
            if (planNum == loadNum) {
                loadVolume = planVolume;
                loadWeight = planWeight;

            } else {
                loadVolume = planVolume.divide(new BigDecimal(planNum), 2, BigDecimal.ROUND_HALF_UP)
                        .multiply(new BigDecimal(loadNum))
                        .setScale(2, BigDecimal.ROUND_HALF_UP);

                loadWeight = planWeight.divide(new BigDecimal(planNum), 2, BigDecimal.ROUND_HALF_UP)
                        .multiply(new BigDecimal(loadNum))
                        .setScale(2, BigDecimal.ROUND_HALF_UP);
            }
            boxStatistics.setLoadVolume(loadVolume);
            boxStatistics.setLoadWeight(loadWeight);

            BigDecimal unloadVolume;
            BigDecimal unloadWeight;
            if (planNum == unloadNum) {
                unloadVolume = planVolume;
                unloadWeight = planWeight;
            } else {
                unloadVolume = planVolume.divide(new BigDecimal(planNum), 2, BigDecimal.ROUND_HALF_UP)
                        .multiply(new BigDecimal(unloadNum))
                        .setScale(2, BigDecimal.ROUND_HALF_UP);

                unloadWeight = planWeight.divide(new BigDecimal(planNum), 2, BigDecimal.ROUND_HALF_UP)
                        .multiply(new BigDecimal(unloadNum))
                        .setScale(2, BigDecimal.ROUND_HALF_UP);
            }
            //平均计算
            boxStatistics.setUnloadVolume(unloadVolume);
            boxStatistics.setUnloadWeight(unloadWeight);
        }
        return boxStatistics;
    }

    @Override
    public BoxGoodsStatistics getBoxStatistics(Long shipmentId) {
        //设置为不能移除的
        //获取所有预装的商品
        List<BoxPreloadGoodsBackVO> goodsItemList = getShipGoodItemList(shipmentId);
        BoxLoadInfoQueryVO boxLoadInfoQueryVO = new BoxLoadInfoQueryVO();
        boxLoadInfoQueryVO.setShipmentId(shipmentId);
        List<BoxLoadInfoDO> loadInfoList = boxLoadInfoService.getBoxLoadInfoList(boxLoadInfoQueryVO);
        List<OrderItemDO> orderItemDOList = convertOrderItemList(goodsItemList);
        List<OrderDO> orderDOList = getOrderListByOrderItem(orderItemDOList);
        BoxGoodsStatistics boxGoodsStatistics = calculateByOrderList(loadInfoList, orderDOList);
        //统计合包箱数量
        calculateBoxMergeSum(shipmentId, boxGoodsStatistics);
        return boxGoodsStatistics;
    }

    /*
    处理问题添加注释
     */
    @Override
    public Map<Long, BoxGoodsStatistics> getBoxStatistics(List<Long> idList) {
        //设置为不能移除的
        //获取所有预装的商品
        List<BoxPreloadGoodsDO> allGoodsItemList =
                boxPreloadGoodsMapper.selectList(
                        new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .in(BoxPreloadGoodsDO::getShipmentId, idList)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        List<OrderItemDO> orderItemDOList =
                convertOrderItemList(BoxPreloadGoodsConvert.INSTANCE.convertList(
                        allGoodsItemList));
        List<OrderDO> allOrderDOList = getOrderListByOrderItem(orderItemDOList);
        Map<Long, OrderDO> allOrderMap = allOrderDOList.stream()
                .collect(Collectors.toMap(OrderDO::getOrderId, v -> v));

        Map<Long, Set<OrderDO>> shipmentOrderMap = new HashMap<>();
        for (BoxPreloadGoodsDO goodsItem : allGoodsItemList) {
            Long shipmentId = goodsItem.getShipmentId();
            Long orderId = goodsItem.getOrderId();
            OrderDO orderDO = allOrderMap.get(orderId);
            // 检查 Map 中是否已存在 shipmentId，如果不存在则创建一个新的 Set
            shipmentOrderMap.computeIfAbsent(
                    shipmentId, k -> new HashSet<>()).add(orderDO);
        }

        //ecw_box_load_info 已装柜标签
        List<BoxLoadInfoDO> allLoadList =
                boxLoadInfoService.list(new LambdaQueryWrapperX<BoxLoadInfoDO>()
                .in(BoxLoadInfoDO::getShipmentId, idList)
        );

        //ecw_box_merge_pkg 合包箱表 添加注释
        List<BoxMergePkgDO> allPkgList =
                boxMergePkgService.list(new LambdaQueryWrapper<BoxMergePkgDO>()
                .in(BoxMergePkgDO::getShipmentId, idList)
        );

        Map<Long, List<BoxLoadInfoDO>> shipmentLoadMap = allLoadList.stream()
                .collect(Collectors.groupingBy(BoxLoadInfoDO::getShipmentId));

        //合包箱数据
        Map<Long, List<BoxMergePkgDO>> shipmentMergeMap = allPkgList.stream()
                .collect(Collectors.groupingBy(BoxMergePkgDO::getShipmentId));

        Map<Long, BoxGoodsStatistics> shipmentStatisticsMap = new HashMap<>();

        for (Long shipmentId : idList) {
            List<BoxLoadInfoDO> loadInfoList = shipmentLoadMap.get(shipmentId);
            Set<OrderDO> orderDOList = shipmentOrderMap.get(shipmentId);
            if (loadInfoList == null) loadInfoList = new ArrayList<>();
            if (orderDOList == null) orderDOList = new HashSet<>();
            BoxGoodsStatistics boxGoodsStatistics =
                    calculateByOrderList(loadInfoList, orderDOList);

            //添加参数，解决合包箱数据为空时不计算预装箱数的BUG
            calculateBoxMergeSum(shipmentMergeMap.get(shipmentId),
                    boxGoodsStatistics,shipmentId);

            shipmentStatisticsMap.put(shipmentId, boxGoodsStatistics);
        }
        return shipmentStatisticsMap;
    }

    @Override
    public String getDocumentInfo(Long shipmentId) {
        Map<String, String> documentInfoMap = baseMapper.getShipmentCustomTypes(shipmentId);
        if (documentInfoMap == null) return null;
        return documentInfoMap.get("customs_type");
    }

    @Override
    public List<BoxPreloadGoodsBackVO> getShipGoodItemList(Long shipmentId) {
        PreloadedReq query = new PreloadedReq();
        query.setShipmentId(shipmentId);
        query.setLang(I18nMessage.getLang());
        //设置为不能移除的
        query.setIsRemove(0);
        return boxPreloadGoodsMapper.orderPreloaded(query);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void remove(Long shipmentId, Collection<Long> orderIdList, Integer deleteType, boolean hasExit) {
        //校验是否在审核中
        boxService.checkApproval(shipmentId, null);

        orderIdList = checkDeleteOrder(shipmentId, deleteType, orderIdList);

        deleteOrderList(shipmentId, orderIdList, 2, hasExit);

        boxService.addOrderLog(orderIdList, OrderShipmentLog.PRELOAD_REMOVE, "理货移出");
    }

    @Override
    public List<OrderDO> getNormalOrderList(Long shipmentId) {
        List<BoxPreloadGoodsDO> dataList = list(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        Set<Long> orderIdSet = dataList.stream()
                .map(BoxPreloadGoodsDO::getOrderId)
                .collect(Collectors.toSet());
        if (CollectionUtil.isEmpty(orderIdSet)) return new ArrayList<>();
        List<Integer> customsTypeList = Arrays.asList(2, 3);
        List<OrderDO> orderList = orderQueryService.getOrderList(orderIdSet);
        orderList = orderList.stream()
                .filter(t -> (t.getCustomsType() != null && customsTypeList.contains(t.getCustomsType())))
                .collect(Collectors.toList());
        return orderList;
    }

    @Override
    public List<BoxPreloadGoodsBackVO> orderItems(PreloadedReq query) {
        return boxPreloadGoodsMapper.orderPreloaded(query);
    }

    /*
    shipmentId 添加出货主表ID shipmentId
    BoxMergePkgDO ecw_box_merge_pkg
     */
    private void calculateBoxMergeSum(List<BoxMergePkgDO> mergePkgDOList,
                                      BoxGoodsStatistics boxGoodsStatistics,
                                      long shipmentId) {
        // 添加修改问题注释掉的代码
        //if (CollectionUtil.isEmpty(mergePkgDOList)) return;
        //shipmentId = mergePkgDOList.get(0).getShipmentId();
        //end 添加修改问题注释掉的代码

        BoxDO box = boxService.getBox(shipmentId);
        if (!TransportTypeEnum.AIR.getType().equals(box.getTransportType())) {
            return;
        }

        //合包箱数据
        List<BoxMergePkgDO> boxMergePkgDOS =
                boxMergePkgService.selectList(BoxMergePkgDO::getShipmentId,
                        shipmentId);
        //合包箱数据和预装箱数据
        List<BoxPreloadGoodsDO> boxPreloadGoodsDOS =
                boxPreloadGoodsMapper.selectList(
                        new LambdaQueryWrapperX<BoxPreloadGoodsDO>().
                                eq(BoxPreloadGoodsDO::getShipmentId, shipmentId).
                                eq(BoxPreloadGoodsDO::getIsRemove, 0));
        //合包箱计划数据
        getMergeData(boxPreloadGoodsDOS, boxMergePkgDOS, boxGoodsStatistics);
        //已出合包数据
        getCheckoutMergeData(shipmentId, boxPreloadGoodsDOS,
                boxMergePkgDOS, boxGoodsStatistics);

        boxGoodsStatistics.setMergePlanVolume(
                boxGoodsStatistics.getMergeVolume());
        boxGoodsStatistics.setMergePlanWeight(
                boxGoodsStatistics.getMergeWeight());

        //已出数
        boxGoodsStatistics.setMergeRealVolume(
                boxGoodsStatistics.getCheckoutMergeVolume());
        boxGoodsStatistics.setMergeRealWeight(
                boxGoodsStatistics.getCheckoutMergeWeight());
    }

    private void calculateBoxMergeSum(Long shipmentId, BoxGoodsStatistics boxGoodsStatistics) {
        BoxDO box = boxService.getBox(shipmentId);
        if (!TransportTypeEnum.AIR.getType().equals(box.getTransportType())) {
            return;
        }
        List<BoxMergePkgDO> boxMergePkgDOS =
                boxMergePkgService.selectList(BoxMergePkgDO::getShipmentId, shipmentId);
        List<BoxPreloadGoodsDO> boxPreloadGoodsDOS =
                boxPreloadGoodsMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>().eq(BoxPreloadGoodsDO::getShipmentId, shipmentId).eq(BoxPreloadGoodsDO::getIsRemove, 0));
        //合包箱计划数据
        getMergeData(boxPreloadGoodsDOS, boxMergePkgDOS, boxGoodsStatistics);
        //已出合包数据
        getCheckoutMergeData(shipmentId, boxPreloadGoodsDOS,
                boxMergePkgDOS, boxGoodsStatistics);
        //已出订单数据
        getCheckoutOrderData(shipmentId, boxPreloadGoodsDOS,
                boxMergePkgDOS, boxGoodsStatistics);
//        calculateBoxMergeSum(mergePkgDOList, boxGoodsStatistics);
    }

    private void getCheckoutOrderData(Long shipmentId, List<BoxPreloadGoodsDO> boxPreloadGoodsDOS, List<BoxMergePkgDO> boxMergePkgDOS, BoxGoodsStatistics boxGoodsStatistics) {
        BigDecimal checkoutOrderVolume = BigDecimal.ZERO;
        BigDecimal checkoutOrderWeight = BigDecimal.ZERO;
        Long checkoutOrderNum = boxLoadInfoService.selectCount(BoxLoadInfoDO::getShipmentId, shipmentId);
        List<Long> preloadOrderIds = boxPreloadGoodsDOS.stream().map(BoxPreloadGoodsDO::getOrderId).distinct().collect(Collectors.toList());
        if (CollectionUtil.isNotEmpty(preloadOrderIds)) {
            for (Long item : preloadOrderIds) {
                OrderDO orderDO = orderService.selectOne(OrderDO::getOrderId, item);
                Long perOrderCount = boxLoadInfoService.selectCount(BoxLoadInfoDO::getOrderId, item);
                double proportionDouble = perOrderCount.doubleValue() / orderDO.getSumNum().doubleValue();
                BigDecimal proportion = new BigDecimal(Double.toString(proportionDouble));
                BigDecimal multiplyVolume = orderDO.getSumVolume().multiply(proportion);
                BigDecimal multiplyWeight = orderDO.getSumWeight().multiply(proportion);
                multiplyVolume = multiplyVolume.setScale(2, RoundingMode.HALF_UP);
                checkoutOrderVolume = checkoutOrderVolume.add(multiplyVolume);
                multiplyWeight = multiplyWeight.setScale(2, RoundingMode.HALF_UP);
                checkoutOrderWeight = checkoutOrderWeight.add(multiplyWeight);
            }
        }
        boxGoodsStatistics.setCheckoutOrderNum(checkoutOrderNum);
        boxGoodsStatistics.setCheckoutOrderVolume(checkoutOrderVolume);
        boxGoodsStatistics.setCheckoutOrderWeight(checkoutOrderWeight);
    }

    private void getCheckoutMergeData(Long shipmentId,
                                      List<BoxPreloadGoodsDO> boxPreloadGoodsDOS,
                                      List<BoxMergePkgDO> boxMergePkgDOS,
                                      BoxGoodsStatistics boxGoodsStatistics) {
        int checkoutMergeNum = 0;
        BigDecimal checkoutMergeVolume = BigDecimal.ZERO;
        BigDecimal checkoutMergeWeight = BigDecimal.ZERO;
        List<Long> preloadOrderIds = boxPreloadGoodsDOS.stream().map(BoxPreloadGoodsDO::getOrderId).distinct().collect(Collectors.toList());
        if (CollectionUtil.isNotEmpty(boxMergePkgDOS)) {
            for (BoxMergePkgDO boxMergePkgDO : boxMergePkgDOS) {

                List<BoxPkgOrderDO> boxPkgOrderDOS = boxPkgOrderService.selectList(BoxPkgOrderDO::getPkgId, boxMergePkgDO.getId());
                if (CollectionUtil.isNotEmpty(boxPkgOrderDOS)) {
                    List<Long> orderIds = boxPkgOrderDOS.stream().map(BoxPkgOrderDO::getOrderId).collect(Collectors.toList());
                    preloadOrderIds.removeAll(orderIds);
                    List<OrderDO> orderDOS = orderService.selectList(OrderDO::getOrderId, orderIds);
                    int orderSumNum = orderDOS.stream().mapToInt(OrderDO::getSumNum).sum();
                    Long loadCount = boxLoadInfoService.selectCount(new LambdaQueryWrapper<BoxLoadInfoDO>()
                            .eq(BoxLoadInfoDO::getShipmentId, shipmentId)
                            .in(BoxLoadInfoDO::getOrderId, orderIds)
                    );
                    if (loadCount.intValue() == orderSumNum) {
                        checkoutMergeNum = checkoutMergeNum + 1;
                        checkoutMergeVolume = checkoutMergeVolume.add(boxMergePkgDO.getSumVolume() == null ? BigDecimal.ZERO : boxMergePkgDO.getSumVolume());
                        checkoutMergeWeight = checkoutMergeWeight.add(boxMergePkgDO.getSumWeight() == null ? BigDecimal.ZERO : boxMergePkgDO.getSumWeight());
                    }
                } else {
                    checkoutMergeNum = checkoutMergeNum + 1;
                    checkoutMergeVolume = checkoutMergeVolume.add(boxMergePkgDO.getSumVolume() == null ? BigDecimal.ZERO : boxMergePkgDO.getSumVolume());
                    checkoutMergeWeight = checkoutMergeWeight.add(boxMergePkgDO.getSumWeight() == null ? BigDecimal.ZERO : boxMergePkgDO.getSumWeight());
                }
            }
        }

        if (CollectionUtil.isNotEmpty(preloadOrderIds)) {
            Long notInMergeOrderCount = boxLoadInfoService.selectCount(new LambdaQueryWrapperX<BoxLoadInfoDO>()
                    .eq(BoxLoadInfoDO::getShipmentId, shipmentId)
                    .in(BoxLoadInfoDO::getOrderId, preloadOrderIds)
            );
            checkoutMergeNum = checkoutMergeNum + (notInMergeOrderCount == null ? 0 : notInMergeOrderCount.intValue());
            //体积和重量按照订单装箱比例来计算
            for (Long item : preloadOrderIds) {
                OrderDO orderDO = orderService.selectOne(OrderDO::getOrderId, item);
                Long perOrderCount = boxLoadInfoService.selectCount(BoxLoadInfoDO::getOrderId, item);
                double proportionDouble = perOrderCount.doubleValue() / orderDO.getSumNum().doubleValue();
                BigDecimal proportion = new BigDecimal(Double.toString(proportionDouble));
                BigDecimal multiplyVolume = orderDO.getSumVolume().multiply(proportion);
                multiplyVolume = multiplyVolume.setScale(2, RoundingMode.HALF_UP);
                BigDecimal multiplyWeight = orderDO.getSumWeight().multiply(proportion);
                multiplyWeight = multiplyWeight.setScale(2, RoundingMode.HALF_UP);
                checkoutMergeVolume = checkoutMergeVolume.add(multiplyVolume);
                checkoutMergeWeight = checkoutMergeWeight.add(multiplyWeight);
            }
        }
        boxGoodsStatistics.setCheckoutMergeNum(checkoutMergeNum);
        boxGoodsStatistics.setCheckoutMergeVolume(checkoutMergeVolume);
        boxGoodsStatistics.setCheckoutMergeWeight(checkoutMergeWeight);
    }

    private void getMergeData(List<BoxPreloadGoodsDO> boxPreloadGoodsDOS,
                              List<BoxMergePkgDO> boxMergePkgDOS, BoxGoodsStatistics boxGoodsStatistics) {
        int mergeNum = 0;
        BigDecimal mergeVolume = BigDecimal.ZERO;
        BigDecimal mergeWeight = BigDecimal.ZERO;
        List<Long> preloadOrderIds =
                boxPreloadGoodsDOS.stream().map(BoxPreloadGoodsDO::getOrderId).
                        distinct().collect(Collectors.toList());

        if (CollectionUtil.isNotEmpty(boxMergePkgDOS)) {
            List<Long> pkgIds =
                    boxMergePkgDOS.stream().map(BoxMergePkgDO::getId).
                            collect(Collectors.toList());
            List<BoxPkgOrderDO> boxPkgOrderDOS =
                    boxPkgOrderService.selectList(BoxPkgOrderDO::getPkgId, pkgIds);
            if (CollectionUtil.isNotEmpty(boxPkgOrderDOS)) {
                List<Long> pkgOrderIds =
                        boxPkgOrderDOS.stream().map(BoxPkgOrderDO::getOrderId).
                                collect(Collectors.toList());
                preloadOrderIds.removeAll(pkgOrderIds);
            }
            mergeNum = mergeNum + boxMergePkgDOS.size();
            mergeVolume = mergeVolume.add(boxMergePkgDOS.stream().filter(item -> Objects.nonNull(item.getSumVolume())).map(BoxMergePkgDO::getSumVolume).reduce(BigDecimal.ZERO, BigDecimal::add));
            mergeWeight = mergeWeight.add(boxMergePkgDOS.stream().filter(item -> Objects.nonNull(item.getSumWeight())).map(BoxMergePkgDO::getSumWeight).reduce(BigDecimal.ZERO, BigDecimal::add));
        }
        //合包数据和预装箱数据累加一起
        if (CollectionUtil.isNotEmpty(preloadOrderIds)) {
            List<OrderDO> orderDOS =
                    orderService.selectList(OrderDO::getOrderId, preloadOrderIds);
            mergeNum = mergeNum +
                    orderDOS.stream().mapToInt(OrderDO::getSumNum).sum();
            mergeVolume = mergeVolume.add(orderDOS.stream().map(OrderDO::getSumVolume).reduce(BigDecimal.ZERO, BigDecimal::add));
            mergeWeight = mergeWeight.add(orderDOS.stream().map(OrderDO::getSumWeight).reduce(BigDecimal.ZERO, BigDecimal::add));
        }
        boxGoodsStatistics.setMergeNum(mergeNum);
        boxGoodsStatistics.setMergeVolume(mergeVolume);
        boxGoodsStatistics.setMergeWeight(mergeWeight);

    }
}
